<?php
declare (strict_types = 1);

namespace app\admin\controller;
use app\common\controller\Json;
use app\common\library\Auth;
use app\admin\library\Host;
use app\common\library\Pub;
use think\facade\Config;
use app\common\library\Btpanel;
use app\common\library\Epanel;
use app\common\library\QqQrcodeLogin;
use think\facade\Db;
use think\facade\Env;
use think\facade\Filesystem;
use app\BaseController;
class Index extends BaseController
{
    public function initialize() {
        parent::initialize();
    }
    public function clear() {
        if (Pub::delete_dir_file(app()->getRootPath()  . 'runtime')) {
            $this->success('清除缓存成功');
        } else {
            $this->error('清除缓存失败');
        }
    }
    public function third() {
        $type = input('type');
        switch ($type) {
            // 获取QQ登录二维码
            case 'getQQLoginQrcode':
                // 获取二维码信息
                list($status, $info) = (new QqQrcodeLogin())->getQrcodeUrl();

                if ($status) {
                    session('qrobot_bind', $info['qrsig']);
                    return Json::success()->data($info)->res();
                }

                return Json::error($info)->res();
                break;
            // 获取QQ登录状态
            case 'getQQLoginStatus':
                // 查询sign
                $qrsig = (string)session('qrobot_bind');

                if (empty($qrsig)) {
                    return Json::error('请先获取二维码')->res();
                }

                list($status, $info) = (new QqQrcodeLogin())->queryStatus($qrsig);

                // 查询失败
                if (!$status) {
                    return Json::error($info)->res();
                }

                // 登录成功
                if ($info['code'] === 3) {
                    // QQ号
                    $qq = $info['msg'];
                    // 获取用户信息
                    $user = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

                    if (Db::table('admin')->where(array('adminqq' => $qq))->find()) {
                        $info['code'] = 4;
                        $info['msg'] = '该QQ已绑定';
                    }
                    if (!Db::table('admin')->where(array('adminuser' => session('adminuser')))->update(['adminqq' => $qq])) {
                        $info['code'] = 4;
                        $info['msg'] = '绑定失败';
                    }

                }

                if (in_array($info['code'], [3, -1])) {
                    session('qrobot_bind', null);
                }

                return Json::success()->data($info)->res();
                break;
        }
        return Json::error('不存在的操作类型')->res();
    }
    public function kami() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $this->assign('admin', $admin);
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('kami_read', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $kmdata = Db::table('kami');
        $this->assign('kmdata', $kmdata->order('money desc')->paginate(20));

        return view();
    }
    public function bt_show() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $this->assign('admin', $admin);
        if ($admin['id'] != 1) {
            $this->error('没有权限', url('/index/index')->build(), 3);
        }
        $id = input('get.id', '', 'htmlspecialchars');
        $serverInfo = Db::table('api')->where('id', $id)->find();
        if (!$serverInfo) {
            $this->error('没有找到该服务器信息');
        }
        if ($serverInfo['type'] != 'bt') {
            $this->error('当前服务器没有控制台');
        }
        $Btpanel = new Btpanel($serverInfo['apiurl'], (new Auth)->decrypt($serverInfo['apikey']));
        if ($serverInfo['os'] == 'linux') {
            $tests = $Btpanel->get_server_status('linux');
        } else {
            $tests = $Btpanel->get_server_status('win');
        }

        if (!$tests) {
            $this->error($Btpanel->getError());
        }

        $type = input('post.type');

        if ($type == 'getGetNetWork') {
            return json_decode($Btpanel->send('GetNetWork'), true);
        } elseif ($type == 're_panel') {
            if (json_decode($Btpanel->send('RepPanel', ['action' => 'RepPanel']), true) == 'true') {
                $this->success('修复成功，请刷新当前页面');
            } else {
                $this->error('修复失败');
            }
        } elseif ($type == 'reweb') {
            if (json_decode($Btpanel->send('ReWeb', ['action' => 'ReWeb']), true)) {
                $this->success('重启面板成功，请刷新当前页面');
            } else {
                $this->error('重启失败');
            }
        } elseif ($type == "CloseLogs") {
            if ($fileSize = json_decode($Btpanel->send('CloseLogs', ['action' => 'CloseLogs']), true)) {
                $this->success('剩余日志大小：' . $fileSize);
            } else {
                $this->error('失败');
            }
        } elseif ($type == "Close_Recycle_bin") {
            if ($Close_Recycle = json_decode($Btpanel->send('Close_Recycle_bin', ['action' => 'Close_Recycle_bin']), true)) {
                $this->success('清理成功');
            } else {
                $this->error('失败');
            }
        } elseif ($type == "reboot") {
            if (json_decode($Btpanel->send('RestartServer', ['action' => 'RestartServer']), true)) {
                $this->success('服务器已重启，请等待服务器启动');
            } else {
                $this->error('重启失败');
            }
        } elseif ($type == "getfile") {
            // 这里要考虑到windows与linux不同文件路径
            $file = input('post.file');
            switch ($file) {
                case 'default':
                    $file = '/www/server/panel/data/defaultDoc.html';
                    break;
                case '404':
                    $file = '/www/server/panel/data/404.html';
                    break;
                case 'nosite':
                    $file = '/www/server/nginx/html/index.html';
                    break;
                case 'stop':
                    $file = '/www/server/stop/index.html';
                    break;
                default:
                    $this->error('请求错误');
                    break;
            }
            if ($fileBody = json_decode($Btpanel->send('GetFileBody', ['path' => $file]), true)) {
                return ['code' => 200,
                    'msg' => '获取成功',
                    'fileBody' => $fileBody];
            } else {
                $this->error('获取失败');
            }
        } elseif ($type == "savefile") {
            // 这里要考虑到windows与linux不同文件路径
            $file = input('post.file');
            $value = input('post.value', '', null);
            switch ($file) {
                case 'default':
                    $file = '/www/server/panel/data/defaultDoc.html';
                    break;
                case '404':
                    $file = '/www/server/panel/data/404.html';
                    break;
                case 'nosite':
                    $file = '/www/server/nginx/html/index.html';
                    break;
                case 'stop':
                    $file = '/www/server/stop/index.html';
                    break;
                default:
                    $this->error('请求错误');
                    break;
            }
            if ($fileBody = json_decode($Btpanel->send('SaveFileBody', ['path' => $file, 'data' => $value, 'encoding' => 'utf-8']), true)) {
                $this->success('保存成功');
            } else {
                $this->error('保存失败');
            }
        } elseif ($type == 'checkUp') {
            $checkUp = json_decode($Btpanel->send('UpdatePanel', ['check' => 'true', 'force' => false]), true);
            if ($checkUp && isset($checkUp['status']) && $checkUp['status'] == 'true') {
                $this->success($checkUp['msg']['updateMsg']);
            } else {
                $this->error('当前版本：' . $checkUp['msg']["version"] . '.暂无更新');
            }
        } elseif ($type == 'update') {
            $UpdatePanels = json_decode($Btpanel->send('UpdatePanel', ['toUpdate' => true]), true);
            if ($UpdatePanels && isset($UpdatePanels['status']) && $UpdatePanels['status'] == 'true') {
                //重启面板
                $Btpanel->send('ReWeb', ['action' => 'ReWeb']);
                $this->success($UpdatePanels['msg']);
            } else {
                $this->error('升级失败');
            }
        } elseif ($type == "install") {
            $sName = input('post.sName');
            $version = input('post.version');
            if (!$sName) {
                $this->error('软件名不能为空');
            }

            $install = json_decode($Btpanel->send('InstallPlugin', ['sName' => $sName, 'version' => $version, 'type' => 0]), true);
            if ($install && isset($install['status']) && $install['status'] == 'true') {
                $this->success($install['msg']);
            } elseif ($install && isset($install['status'])) {
                $this->error($install['msg']);
            } else {
                $this->error('安装失败');
            }
        } elseif ($type == "uninstall") {
            $version = input('post.version');
            $sName = input('post.sName');
            if (!$sName || !$version) {
                $this->error('软件名和版本号不能为空');
            }

            $uninstall = json_decode($Btpanel->send('UnInstallPlugin', ['sName' => $sName, 'version' => $version]), true);
            if ($uninstall && isset($uninstall['status']) && $uninstall['status'] == 'true') {
                $this->success($uninstall['msg']);
            } elseif ($uninstall && isset($uninstall['status'])) {
                $this->error($uninstall['msg']);
            } else {
                $this->error('卸载失败');
            }
        } elseif ($type == "softUp") {
            $sName = input('post.sName');
            if (!$sName) {
                $this->error('软件名不能为空');
            }

            $uninstall = json_decode($Btpanel->send('InstallPlugin', ['sName' => $sName, 'version' => 1, 'type' => 0, 'upgrade' => 1]), true);
            if ($uninstall && isset($uninstall['status']) && $uninstall['status'] == 'true') {
                $this->success($uninstall['msg']);
            } elseif ($uninstall && isset($uninstall['status'])) {
                $this->error($uninstall['msg']);
            } else {
                $this->error('升级失败');
            }
        } else {

            $page = input('get.page') ? input('get.page') : 1;
            $softType = input('get.softType/d') ? input('get.softType/d') : 5;
            $GetSoftList = json_decode($Btpanel->send('GetSoftList', ['p' => $page, 'type' => $softType, 'tojs' => 'soft.get_list', 'force' => '0', 'query' => '']), true); //获取软件运行环境列表
            unset($GetSoftList['type'][6]);
            foreach ($GetSoftList['type'] as $k) {
                $GetSoftLists[$k['id']] = json_decode($Btpanel->send('GetSoftList', ['p' => $page, 'type' => $k['id'], 'tojs' => 'soft.get_list', 'force' => '0', 'query' => '']), true)['list']['data'];
            }

            $GetDiskInfo = json_decode($Btpanel->send('GetDiskInfo'), true); //获取硬盘及分区大小
            $GetSystemTotal = json_decode($Btpanel->send('GetSystemTotal'), true); //获取系统信息
            $hostCount = json_decode($Btpanel->send('Websites', ['p' => '1', 'limit' => '999', 'type' => '-1', 'order' => 'id desc', 'tojs' => '', 'search' => '']), true); //获取站点数量
            $ftpCount = json_decode($Btpanel->send('WebFtpList', ['p' => '1', 'limit' => '999', 'type' => '-1', 'order' => 'id desc', 'tojs' => '', 'search' => '']), true); //获取ftp数量
            $sqlCount = json_decode($Btpanel->send('WebSqlList', ['p' => '1', 'limit' => '999', 'type' => '-1', 'order' => 'id desc', 'tojs' => '', 'search' => '']), true); //获取sql数量
            $riskCount = json_decode($Btpanel->send('warning'), true)['risk'];

            // 面板操作日志
            $logsList = json_decode($Btpanel->send('getData', ['p' => '1', 'limit' => '10', 'table' => 'logs', 'order' => 'id desc', 'tojs' => 'firewall.get_log_list', 'search' => '']), true);
            $logsize = json_decode($Btpanel->send('GetDirSize', ['path' => '/www/wwwlogs']), true);

            if (isset($GetSystemTotal['system']) && mb_stristr($GetSystemTotal['system'], 'windows')) {
                $isWindows = 1;
            } else {
                $isWindows = 0;
            }

            $this->assign("GetSoftList", $GetSoftList);
            $this->assign("GetSoftLists", $GetSoftLists);
            $this->assign("isWindows", $isWindows);

            $this->assign("GetDiskInfo", $GetDiskInfo);
            $this->assign("GetSystemTotal", $GetSystemTotal);
            $this->assign("hostCount", isset($hostCount['data']) ? count($hostCount['data']) : '0');
            $this->assign("ftpCount", isset($ftpCount['data']) ? count($ftpCount['data']) : '0');
            $this->assign("sqlCount", isset($sqlCount['data']) ? count($sqlCount['data']) : '0');
            $this->assign("riskCount", isset($riskCount['data']) ? count($riskCount['data']) : '0');
            $this->assign("softType", $softType);
            $this->assign('logsList', $logsList['data']);
            $this->assign('logsize', $logsize);
            return view();
        }

    }
    public function bttb() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $this->assign('admin', $admin);
        if ($admin['id'] != 1) {
            $this->error('没有权限', url('/index/index')->build(), 3);
        }
        $id = input('post.id', '', 'htmlspecialchars');
        $serverInfo = Db::table('api')->where('id', $id)->find();
        if (!$serverInfo) {
            $this->error('没有找到该服务器信息');
        }
        if ($serverInfo['type'] != 'bt') {
            $this->error('当前服务器没有控制台');
        }
        $Btpanel = new Btpanel($serverInfo['apiurl'], (new Auth)->decrypt($serverInfo['apikey']));
        if ($serverInfo['os'] == 'linux') {
            $tests = $Btpanel->get_server_status('linux');
        } else {
            $tests = $Btpanel->get_server_status('win');
        }

        if (!$tests) {
            $this->error($Btpanel->getError());
        }
        $sites = json_decode($Btpanel->send('Websites',['search' => '','p' => '1','limit' => '1500','type' => '-1','order' => 'id desc','tojs' => '']),true);
        foreach($sites as $site){
        Db::table('bt_host')->where('domain', $site['name'])->update(['web_id' => $site['id']]);
        }
        $ftps = json_decode($Btpanel->send('WebFtpList',['search' => '','p' => '1','limit' => '1500','type' => '-1','order' => 'id desc','tojs' => '']),true);
        foreach($ftps as $ftp){
        Db::table('bt_host')->where('domain', $ftp['name'])->update(['ftp_id' => $ftp['id']]);
        }
        $sqls = json_decode($Btpanel->send('WebSqlList',['search' => '','p' => '1','limit' => '1500','type' => '-1','order' => 'id desc','tojs' => '']),true);
        foreach($sqls as $sql){
        Db::table('bt_host')->where('domain', $sql['name'])->update(['sql_id' => $sql['id']]);
        }
          $this->success('同步成功');

    }

    public function kmadds() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录');
        }
        $scgs = input('post.scgs', '', 'htmlspecialchars');
        $api = input('post.api', '', 'htmlspecialchars');
        $apiid = input('post.apiid', '', 'htmlspecialchars');
        $day = input('post.day', '', 'htmlspecialchars');
        $money = input('post.money', '', 'htmlspecialchars');

        $web = Config::get('website');
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('kami_add', $permission)) {
            $this->error('没有权限');
        }
        for ($i = 1; $i <= $scgs; $i++) {
            $key = Pub::getRandStr();
            $data['km'] = $key;
            $data['api'] = $api;
            $data['apiid'] = $apiid;
            $data['day'] = $day;
            $data['money'] = $money?$money:'0.00';
            $data['state'] = 1;
            if (!Db::table('kami')->insert($data)) {
                $this->error('生成失败，未知错误。');
            }
        }

        $this->success('生成成功，请稍后...');
    }

    public function kmadd() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('kami_add', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);
        }
        $apidata = Db::table('api');

        $this->assign('apidata', $apidata->select());

        return view();
    }

    public function delUserApi() {
        $id = input('post.id', '', 'htmlspecialchars');
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('api_deluser', $permission)) {
            $this->error('没有权限');
        }
        $apidata = Db::table('apib')->where(array('id' => $id))->find();


        if (!Db::table('apib')->where(array('id' => $id))->delete()) {
            $this->error('删除失败，未知错误。');
        }
        $this->success('删除成功，请稍后...');
    }
    public function delworder() {
        $id = input('post.id', '', 'htmlspecialchars');
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('worder_del', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }

        if (!Db::table('worder')->where(array('id' => $id))->delete()||!Db::table('wreply')->where(array('worder' => $id))->delete()) {
            $this->error('删除失败，未知错误。');
        }
        $this->success('删除成功，请稍后...');
    }
    public function delprice() {
        $id = input('post.id', '', 'htmlspecialchars');
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('price_del', $permission)) {
            $this->error('没有权限');
        }

        if (Db::table('user')->where(array('grade' => $id))->count() >= 1) {
            $this->error('该等级尚有用户使用，暂时无法删除。');
        } else {
            if (!Db::table('grade')->where(array('id' => $id))->delete()) {
                $this->error('删除失败，未知错误。');
            }
            $this->success('删除成功，请稍后...');
        }
    }
    public function delapiclass() {
        $id = input('post.id', '', 'htmlspecialchars');
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('apiclass_del', $permission)) {
            $this->error('没有权限');
        }

        if (Db::table('api')->where(array('apiclass' => $id))->count() >= 1) {
            $this->error('该分类尚有接口使用，暂时无法删除。');
        } else {
            if (!Db::table('apiclass')->where(array('id' => $id))->delete()) {
                $this->error('删除失败，未知错误。');
            }
            $this->success('删除成功，请稍后...');
        }
    }
    public function yhapilist() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('user_apilist', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $apidata = Db::table('apib');
        $this->assign('apidata', $apidata->where(array('username' => input('get.username')))->paginate(20));

        return view();
    }

    public function index() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);

        $this->assign('server', Db::table('api')->count());
        $this->assign('user', Db::table('user')->count());
        $money = Db::table('pay')->where(array('date' => date('Y-m-d'), 'state' => 1))->sum('money');
        $this->assign('sumday', $money);
        $sum = Db::table('api')->sum('apiuse');
        $this->assign('apidata', Db::table('api')->select());
        $this->assign('sum', $sum);
        $this->assign('debug', env('APP_DEBUG'));
        return view();
    }
    public function debug() {
        if (input('post.state', '', 'htmlspecialchars') == '1') {
            $val = 'true';
        } else {
            $val = 'false';
        }
        Env::offsetSet('APP_DEBUG', $val);
        Env::offsetSet('DATABASE_DEBUG', $val);
        $envPath = app()->getRootPath() . DIRECTORY_SEPARATOR . '.env';
        $envinidata = Env::get();
        $inicontent = arr_trinsform_ini($envinidata);
        $fp = fopen($envPath, "w") or $this->error("Couldn't open $envPath");
        fputs($fp, $inicontent);
        fclose($fp);
        $this->success('操作成功');
    }

    public function upd() {
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录');
        }
        $file = request()->file('file');

        $result = validate(['file' => ['fileSize' => 102400, 'fileExt' => 'gif,jpg,png']])->check(['file' => $file]);
        if ($result) {

            $path = Filesystem::disk('public')->putFile('upload', $file);

            $picCover = Filesystem::getDiskConfig('public', 'url').'/'.str_replace('\\', '/', $path);


            $fileName = $file->getOriginalName();
            $jsondata = ['status' => '1',
                'info' => '上传成功',
                'location' => request()->domain().$picCover];

        } else {
            $jsondata = ['status' => '0',
                'info' => '文件不符合要求',
                'location' => '文件不符合要求'];
        }
        exit(json_encode($jsondata));
    }

    public function tj() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $auth = new Auth();
        $saveData = [];
        list($status, $data) = $auth->query_recommend($saveData);
        if (false === $status) {
            $this->error($data);
        }
        if (!$auth->signVerify($data)) {
            $this->error('签名验证失败, 请检查授权ID跟授权秘钥');
        }
        $data = $auth->getContent($data);
        if (!$data['status']) {
            $this->error($data['info']);
        }
        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('api_add', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $this->assign('admin', $admin);
        $this->assign('list', $data['data']);

        return view();
    }

    public function userlist() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('user_read', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $userdata = Db::table('user');
        if (empty(input('get.keywords'))) {
            $this->assign('userdata', $userdata->paginate(20));
        } else {
            $this->assign('userdata', $userdata->where(array('username' => input('get.keywords')))->paginate(20));
        }


        return view();
    }
    public function bindqrobot() {
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录', url('/index/login')->build(), 3);
        }
        if (!Db::table('admin')->where(array('adminuser' => session('adminuser')))->update(['adminqq' => ''])) {
            $this->error('解绑失败', url('/index/index')->build(), 3);
        }
        $this->success('解绑成功', url('/index/index')->build(), 3);
    }
    public function hostlist() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('host_read', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $hostdata = Db::table('host');
        if (empty(input('get.keywords'))) {
            $this->assign('hostdata', $hostdata->paginate(20));
        } else {
            $this->assign('hostdata', $hostdata->where(array('hostname' => input('get.keywords')))->paginate(20));
        }


        return view();
    }
    public function hoststatus() {
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }
        if (empty(input('apiip')))$this->error('接口IP缺失');
        $apidata = Db::table('api')->where(array('apiip' => input('apiip')))->find();
        if (empty($apidata))$this->error('平台不存在该接口');
        if ($apidata['self'] == 0) {
            $url = $apidata['apiurl'].'Index/checkapi.html';
            $postdata = array(
                'username' => $apidata['apiusername'],
                'userkey' => (new Auth)->decrypt($apidata['apikey']),
                'apiip' => $apidata['apiip']
            );
            $resultdata = Pub::request_post($url, $postdata);
            $resultdata = json_decode($resultdata, TRUE);
            if ($resultdata['status'] != 1)$this->error('接口通讯失败');
        } else {
            if ($apidata['type'] == 'bt') {
                $panel = new Btpanel($apidata['apiurl'], (new Auth)->decrypt($apidata['apikey']));
                if ($apidata['os'] == 'linux') {
                    $apistate = $panel->get_server_status('linux');
                } else {
                    $apistate = $panel->get_server_status('win');
                }
            } else {
                $panel = new Epanel($apidata['apiurl'], (new Auth)->decrypt($apidata['apikey']));
                $apistate = $panel ->test();
            }
            if ($apistate == false) {
                $this->error('接口通讯失败');
            }
        }

        $hostname = input('hostname');
        $status = input('status');
        if ($apidata['self'] == 0) {
            $url = $apidata['apiurl'].'Index/updatestatus.html';
            $postdata = array(
                'username' => $apidata['apiusername'],
                'userkey' => (new Auth)->decrypt($apidata['apikey']),
                'apiip' => $apidata['apiip'],
                'hostname' => $hostname,
                'status' => $status
            );
            $resultdata = Pub::request_post($url, $postdata);
            $resultdata = json_decode($resultdata, TRUE);
            if ($resultdata['status'] != 1)$this->error('1:修改失败');
        } else {
            $resultdata = $panel ->changeStatus($hostname, $status);

            if ($resultdata['result'] != 200)$this->error('修改失败');
        }

        Db::table('host')->where(array('hostname' => $hostname, 'hostip' => $apidata['apiip']))->update(['hoststate' => $status]);
        $this->success('修改成功');
    }
    public function hostdel() {
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }
        if (empty(input('apiip')))$this->error('接口IP缺失');
        $apidata = Db::table('api')->where(array('apiip' => input('apiip')))->find();
        if (empty($apidata))$this->error('平台不存在该接口');
        if ($apidata['self'] == 0) {
            $url = $apidata['apiurl'].'Index/checkapi.html';
            $postdata = array(
                'username' => $apidata['apiusername'],
                'userkey' => (new Auth)->decrypt($apidata['apikey']),
                'apiip' => $apidata['apiip']
            );
            $resultdata = Pub::request_post($url, $postdata);
            $resultdata = json_decode($resultdata, TRUE);
            if ($resultdata['status'] != 1)$this->error('接口通讯失败');
        } else {
            if ($apidata['type'] == 'bt') {
                $panel = new Btpanel($apidata['apiurl'], (new Auth)->decrypt($apidata['apikey']));
                if ($apidata['os'] == 'linux') {
                    $apistate = $panel->get_server_status('linux');
                } else {
                    $apistate = $panel->get_server_status('win');
                }
            } else {
                $panel = new Epanel($apidata['apiurl'], (new Auth)->decrypt($apidata['apikey']));
                $apistate = $panel ->test();
            }
            if ($apistate == false) {
                $this->error('接口通讯失败');
            }
        }

        $hostname = input('hostname');

        if ($apidata['self'] == 0) {
            $url = $apidata['apiurl'].'Index/delhost.html';
            $postdata = array(
                'username' => $apidata['apiusername'],
                'userkey' => (new Auth)->decrypt($apidata['apikey']),
                'apiip' => $apidata['apiip'],
                'hostname' => $hostname
            );
            $resultdata = Pub::request_post($url, $postdata);
            $resultdata = json_decode($resultdata, TRUE);
            if ($resultdata['status'] != 1)$this->error('1:删除失败');
        } else {
            $resultdata = $panel ->delSite($hostname);

            if ($resultdata['result'] != 200)$this->error('删除失败'.$resultdata['msg']);
        }

        Db::table('host')->where(array('hostname' => $hostname, 'hostip' => $apidata['apiip']))->delete();
        $this->success('删除成功');
    }
    public function hostadd() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('host_add', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $this->assign('apidata', Db::table('api')->select());
        if ($this->request->isPost()) {

            $result = Host::createhost(input());
            if ($result['code'] == '0') {
                $this->error('开通失败,原因'.$result['msg']);
            }
            $apidataw = Db::table('api')->where(array('apiip' => input('apiip')))->find();
            Db::table('api')->where(array('apiip' => input('apiip')))->update(['apiuse' => $apidataw['apiuse'] + 1]);
            $this->success('开通成功');

        }


        return view();
    }

    public function apilist() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('api_read', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $apidata = Db::table('api');

        $this->assign('apidata', $apidata->paginate(20));

        return view();
    }
    public function adminlist() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('admin_read', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $admindata = Db::table('admin');

        $this->assign('admindata', $admindata->paginate(20));

        return view();
    }
    public function worder() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('worder_read', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $listdata = Db::table('worder');

        $this->assign('listdata', $listdata->paginate(20));

        return view();
    }

    public function lhost_add() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('api_add', $permission)) {
            $this->error('没有权限');

        }
        $domain = input('post.domain', '', 'htmlspecialchars');
        $domains = input('post.domains', '', 'htmlspecialchars');
        $username = input('post.username', '', 'htmlspecialchars');
        $userkey = input('post.userkey', '', 'htmlspecialchars');
        if ($domains == $_SERVER['HTTP_HOST'])$this->error('不能对接自己');
        $resultdata = Pub::request_post($domain.'/api/index/apilist.html', ['apiip' => '127.0.0.1', 'username' => $username, 'userkey' => $userkey]);
        if (empty($resultdata)) {
            $this->error('获取接口失败,原因：网站无法连接');
        }
        $resultdata = json_decode($resultdata, TRUE);
        if ($resultdata['status'] != 1) $this->error('获取接口失败,原因：'.$resultdata['info']);
        $this->success($resultdata['data']);
    }

    public function apidis() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('apidis', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $apidata = Db::table('api');

        $this->assign('apidata', $apidata->select());

        return view();
    }

    public function apidiss() {
        $username = input('post.username', '', 'htmlspecialchars');
        $ip = input('post.ip', '', 'htmlspecialchars');
        $uselength = input('post.uselength', '', 'htmlspecialchars');

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('apidis', $permission)) {

            $this->error('没有权限');
        }
        $userdata = Db::table('user')->where(array('username' => $username))->find();
        if (empty($userdata)) {
            $this->error('用户不存在');
        }
        $apidata = Db::table('api')->where(array('apiip' => $ip))->find();

        if (empty($apidata)) {
            $this->error('API不存在');
        }

        $data['username'] = $username;
        $data['apiip'] = $ip;
        $data['uselength'] = $uselength;
        $data['usetime'] = date('Y-m-d');
        $data['apiname'] = $apidata['apiname'];
        $data['apimoney'] = $apidata['apimoney'];
        $data['apiusemoney'] = $apidata['apiusemoney'];
        $apidatas = Db::table('apib')->where(array('apiip' => $ip, 'username' => $username))->find();
        if (empty($apidatas)) {
            if (!Db::table('apib')->insert($data)) {
                $this->error('划拨失败，未知错误。');
            }
        } else {
            $datas['uselength'] = $apidatas['uselength'] + $uselength;
            if (!Db::table('apib')->where(array('apiip' => $ip, 'username' => $username))->update($datas)) {
                $this->error('划拨失败，未知错误。');
            }
        }
        $this->cron('1');
        $this->success('划拨成功，请稍后...');
    }
    public function cron($type = '0') {
        $data = Db::table('apib')->where(array('isshow' => 1))->select();
        foreach ($data as $item) {
            $goodday = $item['uselength']*24*60*60;
            $cd = round(((strtotime($item['usetime'])+$goodday)-time())/24/3600, 2);
            $item_id = $item['id'];
            if ($cd <= 0) {
                Pub::LingduMsg('接口删除提醒！', '接口IP：'.$item['apiip'].'<br/>删除原因：接口到期自动删除<br/>请您下次及时续费确保接口的正常！', $item['username']);
                Db::table('apib')->where(array('id' => $item_id))->delete();
            }
            $cron['uselengthcd'] = $cd;
            $result = Db::table('apib')->where(array('id' => $item_id))->update($cron);
            if ($type == '0')echo "执行成功 ID:".$item_id."</br>";

        }
    }
    public function noticelist() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('notice_read', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);
        }
        $noticedata = Db::table('notice');

        $this->assign('noticedata', $noticedata->paginate(20));

        return view();
    }

    public function noticeadd() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('notice_add', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }

        return view();
    }

    public function apiadd() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('api_add', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }

        return view();
    }
    public function adminadd() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('admin_add', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }

        return view();
    }

    public function kl() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('api_kl', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }

        return view();
    }

    public function userState() {
        $id = input('post.id', '', 'htmlspecialchars');

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('user_state', $permission)) {

            $this->error('没有权限');
        }
        $getuser = Db::table('user')->where(array('id' => $id))->find();
        $userstate = 1;
        if ($getuser['userstate']) {
            $userstate = 0;
        }
        $data['userstate'] = $userstate;
        if (!Db::table('user')->where(array('id' => $id))->update($data)) {
            $this->error('修改失败，未知错误。');
        }
        $this->success('修改成功，请稍后...');
    }

    public function delnotice() {
        $id = input('post.id', '', 'htmlspecialchars');

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('notice_del', $permission)) {
            $this->error('没有权限');
        }
        $noticedata = Db::table('notice')->where(array('id' => $id))->find();
        if (empty($noticedata)) {
            $this->error('公告不存在');
        }

        if (!Db::table('notice')->where(array('id' => $id))->delete()) {
            $this->error('删除失败，未知错误。');
        }
        $this->success('删除成功，请稍后...');

    }
    public function delkm() {
        $id = input('post.id', '', 'htmlspecialchars');

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('kami_del', $permission)) {
            $this->error('没有权限');
        }
        $data = Db::table('kami')->where(array('id' => $id))->find();
        if (empty($data)) {
            $this->error('卡密不存在');
        }

        if (!Db::table('kami')->where(array('id' => $id))->delete()) {
            $this->error('删除失败，未知错误。');
        }
        $this->success('删除成功，请稍后...');

    }

    public function delApi() {
        $id = input('post.id', '', 'htmlspecialchars');

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('api_del', $permission)) {
            $this->error('没有权限');
        }
        $apidata = Db::table('api')->where(array('id' => $id))->find();
        if (empty($apidata)) {
            $this->error('接口不存在');
        }
        if (Db::table('bt_host')->where(array('server' => $apidata['apiip']))->count() >= 1) {
            $this->error('该分类尚有接口使用，暂时无法删除。');
        } else {
            if (!Db::table('api')->where(array('id' => $id))->delete()) {
                $this->error('删除失败，未知错误。');
            }
            $this->success('删除成功，请稍后...');
        }
    }
    public function deladmin() {
        $id = input('post.id', '', 'htmlspecialchars');

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('admin_del', $permission)) {
            $this->error('没有权限');
        }
        $admindata = Db::table('admin')->where(array('id' => $id))->find();
        if (empty($admindata)) {
            $this->error('管理不存在');
        }
        if ($admindata['id'] == 1) {
            $this->error('超级管理员不得删除');
        }

        if (!Db::table('admin')->where(array('id' => $id))->delete()) {
            $this->error('删除失败，未知错误。');
        }
        $this->success('删除成功，请稍后...');

    }

    public function verify() {
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录');
        }
        $id = input('post.id', '', 'htmlspecialchars');

        $apidata = Db::table('api')->where(array('id' => $id))->find();
        if ($apidata['self'] == 0) {
            $url = $apidata['apiurl'].'Index/checkapi.html';
            $postdata = array(
                'username' => $apidata['apiusername'],
                'userkey' => (new Auth)->decrypt($apidata['apikey']),
                'apiip' => $apidata['apiip']
            );
            $resultdata = Pub::request_post($url, $postdata);
            $resultdata = json_decode($resultdata, TRUE);
            if ($resultdata['status'] == 1) {
                $apistate = true;
            } else {
                $apistate = false;
            }
        } else {
            if ($apidata['type'] == 'bt') {
                $this->panel = new Btpanel($apidata['apiurl'], (new Auth)->decrypt($apidata['apikey']));
                if ($apidata['os'] == 'linux') {
                    $apistate = $this->panel->get_server_status('linux');
                } else {
                    $apistate = $this->panel->get_server_status('win');
                }
            } else {
                $this->panel = new Epanel($apidata['apiurl'], (new Auth)->decrypt($apidata['apikey']));
                $apistate = $this->panel ->test();
            }
        }

        if ($apistate) {
            $edit = Db::table('api')->where(array('id' => $id))->update(['apistate' => '1']);
        } else {
            $edit = Db::table('api')->where(array('id' => $id))->update(['apistate' => '2']);
        }

        if (!$edit)$this->error('检测完毕，接口没有变化');
        $this->success('检测完毕，请稍后...');
    }

    public function isShow() {
        $id = input('post.id', '', 'htmlspecialchars');


        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('api_isshow', $permission)) {
            $this->error('没有权限');
        }

        $apidata = Db::table('api')->where(array('id' => $id))->find();
        $isshow = 1;
        if ($apidata['isshow']) {
            $isshow = 0;
        }

        $jk['isshow'] = $isshow;
        if (!Db::table('api')->where(array('id' => $id))->update($jk)) {
            $this->error('修改失败，未知错误。');
        }
        $this->success('修改成功，请稍后...');
    }
    public function isShowapiclass() {
        $id = input('post.id', '', 'htmlspecialchars');


        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('apiclass_isshow', $permission)) {
            $this->error('没有权限');
        }

        $apidata = Db::table('apiclass')->where(array('id' => $id))->find();
        $isshow = 1;
        if ($apidata['isshow']) {
            $isshow = 0;
        }

        $jk['isshow'] = $isshow;
        if (!Db::table('apiclass')->where(array('id' => $id))->update($jk)) {
            $this->error('修改失败，未知错误。');
        }
        $this->success('修改成功，请稍后...');
    }
    public function delUser() {
        $id = input('post.id', '', 'htmlspecialchars');

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('user_del', $permission)) {
            $this->error('没有权限');
        }
        $userdata = Db::table('user')->where(array('id' => $id))->find();
        if (empty($userdata)) {
            $this->error('用户不存在');
        }

        if (!Db::table('user')->where(array('id' => $id))->delete()) {
            $this->error('删除失败，未知错误。');
        }
        $this->success('删除成功，请稍后...');

    }

    public function web() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);
        $this->assign('index_template', Pub::getFolderList(app()->getRootPath().'app/index/view'));
        $this->assign('login_reg_template', Pub::getFolderList(app()->getRootPath().'app/user/view/login_reg'));
        $this->assign('user_template', Pub::getFolderList(app()->getRootPath().'app/user/view/user'));
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('web_info', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);
        }
        if ($this->request->isPost()) {
            $file = app()->getRootPath()  . 'config/website.php';
            file_put_contents($file, '<?php' . "\n\nreturn " . var_export(input('post.'), true) . ";");
            $this->success('修改成功');


        }

        return view();
    }


    public function userinfo() {
        $id = input('get.id', '', 'htmlspecialchars');


        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }
        if (!$id) {
            $this->error('参数错误', url('/index/index'), 3);
        }
        $userdata = Db::table('user')->where(array('id' => $id))->find();
        if (empty($userdata)) {
            $this->error('用户不存在', url('/index/index'), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('user_info', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $userdata = Db::table('user');
        $this->assign('userdata', $userdata->where(array('id' => $id))->find());
        $this->assign('grade', Db::table('grade')->select());

        return view();
    }

    public function noticeinfo() {
        $id = input('get.id', '', 'htmlspecialchars');


        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }
        if (!$id) {
            $this->error('参数错误', url('/index/index'), 3);
        }
        $noticedata = Db::table('notice')->where(array('id' => $id))->find();
        if (empty($noticedata)) {
            $this->error('公告不存在', url('/index/index'), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('notice_info', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $noticedata = Db::table('notice');
        $this->assign('noticedata', $noticedata->where(array('id' => $id))->find());

        return view();
    }
    public function priceinfo() {
        $id = input('get.id', '', 'htmlspecialchars');


        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }
        if (!$id) {
            $this->error('参数错误', url('/index/index'), 3);
        }
        $data = Db::table('grade')->where(array('id' => $id))->find();
        if (empty($data)) {
            $this->error('等级不存在', url('/index/index'), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('price_info', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $data = Db::table('grade');
        $this->assign('data', $data->where(array('id' => $id))->find());

        return view();
    }

    public function apiinfo() {
        $id = input('get.id', '', 'htmlspecialchars');


        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }
        if (!$id) {
            $this->error('参数错误', url('/index/index'), 3);
        }
        $apidata = Db::table('api')->where(array('id' => $id))->find();
        if (empty($apidata)) {
            $this->error('接口不存在', url('/index/index'), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('api_info', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $apidata = Db::table('api');
        $this->assign('apidata', $apidata->where(array('id' => $id))->find());
        $this->assign('apiclass', Db::table('apiclass')->where('isshow', '1')->select());
        return view();
    }
    public function admininfo() {
        $id = input('get.id', '', 'htmlspecialchars');


        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }
        if (!$id) {
            $this->error('参数错误', url('/index/index'), 3);
        }
        $admindata = Db::table('admin')->where(array('id' => $id))->find();
        if (empty($admindata)) {
            $this->error('管理不存在', url('/index/index'), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);

        $permission = json_decode($admin['permission'], true);

        if ($admin['id'] != 1 && !in_array('admin_info', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $this->assign('permission', json_decode($admindata['permission']));
        $admindata = Db::table('admin');
        $this->assign('admindata', $admindata->where(array('id' => $id))->find());

        return view();
    }
    public function worderinfo() {
        $id = input('get.id', '', 'htmlspecialchars');


        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }
        if (!$id) {
            $this->error('参数错误', url('/index/index'), 3);
        }
        $data = Db::table('worder')->where(array('id' => $id))->find();
        if (empty($data)) {
            $this->error('工单不存在', url('/index/index'), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('worder_info', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $rowdata = Db::table('worder');
        $this->assign('rowdata', $rowdata->where(array('id' => $id))->find());
        $data = Db::table('wreply');

        $this->assign('data', $data->where(array('worder' => $id))->order('time')->select());

        return view();
    }

    public function worderinfos() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();


        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('worder_info', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);
            $this->error('没有权限');
        }
        $data['person'] = session('adminuser');
        $data['content'] = input('post.content');
        $data['worder'] = input('post.id');
        $data['time'] = date('Y-m-d H:i:s');
        Db::table('wreply')->insert($data);
        $datas['status'] = 1;
        Db::table('worder')->where(array('id' => input('post.id')))->update($datas);
        $name = Db::table('worder')->where(array('id' => input('post.id')))->find();
        $user = Db::table('user')->where(array('id' => $name['id']))->find();


        $this->success('回复成功');
    }

    public function noticeadds() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('notice_add', $permission)) {

            $this->error('没有权限');
        }
        $_POST['time'] = date('Y-m-d');
        $_POST['adminuser'] = session('adminuser');
        if (!Db::table('notice')->insert($_POST)) {
            $this->error('添加失败，未知错误。');
        }


        $this->success('添加成功');
    }
    public function price() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('price_read', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $listdata = Db::table('grade');

        $this->assign('listdata', $listdata->order('weight')->paginate(20));

        return view();
    }
    public function apiclasslist() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('apiclass_read', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }
        $listdata = Db::table('apiclass');

        $this->assign('listdata', $listdata->paginate(20));

        return view();
    }
    public function priceadd() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('price_add', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }


        return view();
    }
    public function apiclassadd() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('apiclass_add', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }


        return view();
    }
    public function priceinfos() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();


        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('price_info', $permission)) {
            $this->error('没有权限');
        }
        $data = Db::table('grade')->where(array('id' => input('post.id')))->find();
        if (empty($data)) {
            $this->error('等级不存在');
        }
        if (!Db::table('grade')->where(array('id' => input('post.id')))->update(input('post.'))) {
            $this->error('修改失败，未知错误。');
        }
        $this->success('修改成功');
    }
    public function priceadds() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('price_add', $permission)) {
            $this->error('没有权限');
        }
        if (!Db::table('grade')->insert(input('post.'))) {
            $this->error('添加失败，未知错误。');
        }
        $this->success('添加成功');
    }
    public function apiclassadds() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('apiclass_add', $permission)) {
            $this->error('没有权限');
        }
        if (!Db::table('apiclass')->insert(input('post.'))) {
            $this->error('添加失败，未知错误。');
        }
        $this->success('添加成功');
    }
    public function apiadds() {
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录');
        }
        $data['self'] = input('post.self', '', 'htmlspecialchars');
        $data['type'] = input('post.type', '', 'htmlspecialchars');
        $data['apiip'] = input('post.apiip', '', 'htmlspecialchars');
        $data['apiurl'] = input('post.apiurl', '', 'htmlspecialchars');
        $data['apiusername'] = input('post.apiusername', '', 'htmlspecialchars');
        $data['apikey'] = (new Auth())->encrypt(input('post.apikey', '', 'htmlspecialchars'));
        $data['apimoney'] = input('post.apimoney', '', 'htmlspecialchars');
        $data['apiusemoney'] = input('post.apiusemoney', '', 'htmlspecialchars');
        $data['os'] = input('post.os', '', 'htmlspecialchars');
        $data['ftp_server'] = input('post.ftp_server', '', 'htmlspecialchars');
        $data['ftp_port'] = input('post.ftp_port', '', 'htmlspecialchars');
        $data['phpmyadmin_url'] = input('post.phpmyadmin_url', '', 'htmlspecialchars');
        $data['upload_size'] = input('post.upload_size', '', 'htmlspecialchars');
        $data['kzurl'] = input('post.kzurl', '', 'htmlspecialchars');

        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('api_add', $permission)) {

            $this->error('没有权限');
        }
        $apidata = Db::table('api')->where(array('apiip' => $data['apiip']))->find();
        if (!empty($apidata)) {
            $this->error('API已存在');
        }
        if (!Db::table('api')->insert($data)) {
            $this->error('添加失败，未知错误。');
        }
        $this->success('添加成功');
    }

    public function adminadds() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录');
        }
        $data['adminuser'] = input('post.adminuser', '', 'htmlspecialchars');
        $data['adminpwd'] = password_hash(input('post.adminpwd', '', 'htmlspecialchars'), PASSWORD_DEFAULT);
        $data['adminqq'] = input('post.adminqq', '', 'htmlspecialchars');
        $data['permission'] = json_encode(input('post.permission', '', 'htmlspecialchars'));
        if (empty($data['adminuser']) || empty($data['adminpwd']) || empty($data['adminqq']) || empty($data['permission'])) {
            $this->error('不可为空');

        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('admin_add', $permission)) {
            $this->error('没有权限');
        }
        $admindata = Db::table('admin')->where(array('adminuser' => $data['adminuser']))->find();
        if (!empty($admindata)) {
            $this->error('管理已存在');
        }

        if (!Db::table('admin')->insert($data)) {
            $this->error('添加失败，未知错误。');
        }
        $this->success('添加成功');
    }

    public function admininfos() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录');
        }
        $data['id'] = input('post.id', '', 'htmlspecialchars');
        $data['adminuser'] = input('post.adminuser', '', 'htmlspecialchars');
        $adminpwd = input('post.adminpwd', '', 'htmlspecialchars');
        $data['adminqq'] = input('post.adminqq', '', 'htmlspecialchars');
        $data['permission'] = json_encode(input('post.permission', '', 'htmlspecialchars'));
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();


        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('admin_info', $permission)) {
            $this->error('没有权限');
        }
        $admindata = Db::table('admin')->where(array('id' => $data['id']))->find();
        if (empty($admindata)) {
            $this->error('管理不存在');
        }
        if (!empty($adminpwd)) {
            $data['adminpwd'] = password_hash($adminpwd, PASSWORD_DEFAULT);
        }
        if (!Db::table('admin')->where(array('id' => $data['id']))->update($data)) {
            $this->error('修改失败，未知错误。');
        }
        $this->success('修改成功');
    }
    public function lhost_adds() {
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('api_add', $permission)) {
            $this->error('没有权限');
        }
        $data['apiip'] = input('post.apiip', '', 'htmlspecialchars');
        $data['apikey'] = (new Auth)->encrypt(input('post.userkey', '', 'htmlspecialchars'));
        $data['self'] = 0;
        $data['apiusername'] = input('post.username', '', 'htmlspecialchars');
        $data['apimoney'] = input('post.apimoney', '', 'htmlspecialchars');
        $data['apiurl'] = input('post.domain', '', 'htmlspecialchars');
        $data['apiname'] = input('post.apiname', '', 'htmlspecialchars');
        $data['apiuse'] = 0;
        $data['type'] = input('post.type', '', 'htmlspecialchars');
        $data['apimixweb'] = input('post.apimixweb', '', 'htmlspecialchars');
        $data['apimixdb'] = input('post.apimixdb', '', 'htmlspecialchars');
        $data['apimixflow'] = input('post.apimixflow', '', 'htmlspecialchars');
        $data['apiusemoney'] = input('post.apiusemoney', '', 'htmlspecialchars');
        $data['kzurl'] = input('post.kzurl', '', 'htmlspecialchars');
        $data['isshow'] = 0;
        $apidata = Db::table('api')->where(array('apiip' => $data['apiip']))->find();
        if (!empty($apidata)) {
            $this->error('API已存在');
        }
        if (!Db::table('api')->insert($data)) {
            $this->error('添加失败');
        }
        $this->success('添加成功');
    }


    public function noticeinfos() {
        $data['id'] = input('post.id', '', 'htmlspecialchars');
        $data['title'] = input('post.title', '', 'htmlspecialchars');
        $data['content'] = input('post.content', '', 'htmlspecialchars');

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录');
        }
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();


        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('notice_info', $permission)) {
            $this->error('没有权限');
        }
        $noticedata = Db::table('notice')->where(array('id' => $data['id']))->find();
        if (empty($noticedata)) {
            $this->error('公告不存在');
        }

        if (!Db::table('notice')->where(array('id' => $data['id']))->update($data)) {
            $this->error('修改失败，未知错误。');
        }

        $this->success('修改成功');
    }

    public function apiinfos() {
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录');
        }
        $data['id'] = input('post.id', '', 'htmlspecialchars');
        $data['type'] = input('post.type', '', 'htmlspecialchars');
        $data['self'] = input('post.self', '', 'htmlspecialchars');
        $data['apiname'] = input('post.apiname', '', 'htmlspecialchars');
        $data['apiip'] = input('post.apiip', '', 'htmlspecialchars');
        $data['apiusername'] = input('post.apiusername', '', 'htmlspecialchars');
        $data['apiurl'] = input('post.apiurl', '', 'htmlspecialchars');
        $apikey = input('post.apikey', '', 'htmlspecialchars');
        $data['kzurl'] = input('post.kzurl', '', 'htmlspecialchars');
        $data['apinotice'] = input('post.apinotice', '', 'htmlspecialchars');
        $data['apiclass'] = input('post.apiclass', '', 'htmlspecialchars');
        $data['apimoney'] = input('post.apimoney', '', 'htmlspecialchars');
        $data['apiusemoney'] = input('post.apiusemoney', '', 'htmlspecialchars');
        $data['apimixweb'] = input('post.apimixweb', '', 'htmlspecialchars');
        $data['apimixdb'] = input('post.apimixdb', '', 'htmlspecialchars');
        $data['apimixflow'] = input('post.apimixflow', '', 'htmlspecialchars');
        $data['os'] = input('post.os', '', 'htmlspecialchars');
        $data['ftp_server'] = input('post.ftp_server', '', 'htmlspecialchars');
        $data['ftp_port'] = input('post.ftp_port', '', 'htmlspecialchars');
        $data['cert'] = input('post.cert', '', 'htmlspecialchars');
        $data['phpmyadmin_url'] = input('post.phpmyadmin_url', '', 'htmlspecialchars');
        $data['upload_size'] = input('post.upload_size', '', 'htmlspecialchars');


        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('api_info', $permission)) {

            $this->error('没有权限');
        }
        $apidata = Db::table('api')->where(array('id' => $data['id']))->find();
        if (empty($apidata)) {
            $this->error('接口不存在');
        }
        if (!empty($apikey)) {
            $data['apikey'] = (new Auth)->encrypt($apikey);
        }
        if (!Db::table('api')->where(array('id' => $data['id']))->update($data)) {
            $this->error('修改失败，未知错误。');
        }
        if ($data['apiip'] != $apidata['apiip'] || !empty($apikey)) {
            $edit = Db::table('api')->where(array('id' => $data['id']))->update(['apistate' => 0]);
            foreach (Db::table('host')->where(array('hostip' => $apidata['apiip']))->select() as $v) {
                Db::table('host')->where(array('id' => $v['id']))->update(['hostip' => $data['apiip']]);
            }
        }
        $this->success('修改成功');
    }
    public function apiclass_info() {
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录');
        }
        $id = input('post.id', '', 'htmlspecialchars');
        $data['apiclassname'] = input('post.name', '', 'htmlspecialchars');
        if (!Db::table('apiclass')->where(array('id' => $id))->update($data)) {
            $this->error('修改失败，未知错误。');
        }
        $this->success('修改成功');
    }

    public function userinfos() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录');
        }
        $data['id'] = input('post.id', '', 'htmlspecialchars');
        $data['username'] = input('post.username', '', 'htmlspecialchars');
        $userpwd = input('post.userpwd', '', 'htmlspecialchars');
        if (!empty($userpwd)) {
            $data['userpwd'] = password_hash($userpwd, PASSWORD_DEFAULT);
        }
        $data['usermoney'] = input('post.usermoney', '', 'htmlspecialchars');
        $data['useremail'] = input('post.useremail', '', 'htmlspecialchars');
        $data['userqq'] = input('post.userqq', '', 'htmlspecialchars');
        $data['userphone'] = input('post.userphone', '', 'htmlspecialchars');
        $data['ps'] = input('post.ps', '', 'htmlspecialchars');
        $data['grade'] = input('post.usergrade');
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();


        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('user_info', $permission)) {
            $this->error('没有权限');
        }
        $userdata = Db::table('user')->where(array('id' => $data['id']))->find();
        if (empty($userdata)) {
            $this->error('用户不存在');
        }

        if (!Db::table('user')->where(array('id' => $data['id']))->update($data)) {
            $this->error('修改失败，未知错误。');
        }

        $userdata1 = Db::table('user')->where(array('id' => $data['id']))->find();
        $this->success('修改成功');
    }


    public function administrators() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);
        $admindata = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admindata', $admindata);

        return view();
    }

    public function administratorsinfo() {
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录');
        }
        $id = input('post.id', '', 'htmlspecialchars');
        $data['adminuser'] = input('post.adminuser', '', 'htmlspecialchars');
        $data['adminqq'] = input('post.adminqq', '', 'htmlspecialchars');
        $adminpwd = input('post.adminpwd', '', 'htmlspecialchars');
        $admindata = Db::table('admin')->where(array('id' => $id))->find();

        if (!empty($adminpwd)) {
            if (password_verify($adminpwd, $admindata['adminpwd'])) {
                $this->error('与原密码相同！');
            }
            $data['adminpwd'] = password_hash($adminpwd, PASSWORD_DEFAULT);
        }
        if (!Db::table('admin')->where(array('id' => $id))->update($data)) {
            $this->error('修改失败，未知错误。');
        }
        session('adminuser', null);
        session('adminqq', null);
        $this->success('修改成功');

    }

    public function login() {
        $qqlogin = input('get.qqlogin', '', 'htmlspecialchars');


        $logout = input('get.logout', '', 'htmlspecialchars');

        if ($qqlogin) {

            $ssl = $_SERVER['SERVER_PORT'] == '443' ? 'https://' : 'http://';

            $redirect = $ssl . $_SERVER['SERVER_NAME'] . url('/index/logins');

            $url = Pub::qqLogin($redirect);

            return redirect($url);
        }

        if ($logout) {


            session('adminuser', null);
            session('adminqq', null);
            $this->success('退出成功', url('/index/login')->build(), 3);
        }
        if (session('adminuser') && session('adminqq')) {
            $this->error('您已登录!', url('/index/index')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);

        return view();
    }


    public function bindqq() {
        $code = input('get.code', '', 'htmlspecialchars');

        $state = input('get.state', '', 'htmlspecialchars');

        if ($code) {
            if ($state != session('state')) {
                $this->error('Key验证失败', url('/index/index')->build(), 3);
            }

            $data = Db::table('admin')->where(array('qqopenid' => $code))->find();

            if (!empty($data)) {
                $this->error('该QQ已被绑定', url('/index/index')->build(), 3);
            }

            $bdqq['qqopenid'] = $code;
            if (!Db::table('admin')->where(array('adminuser' => session('adminuser')))->update($bdqq)) {
                $this->error('绑定失败', url('/index/index')->build(), 3);
            }
            session('state', null);
            $this->success('绑定成功', url('/index/index')->build(), 3);
        }

        $ssl = $_SERVER['SERVER_PORT'] == '443' ? 'https://' : 'http://';

        $redirect = $ssl . $_SERVER['SERVER_NAME'] . url('/index/bindqq')->build();

        $url = Pub::qqLogin($redirect);

        return redirect($url);
    }


    public function useradd() {

        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录!', url('/index/login')->build(), 3);
        }

        $web = Config::get('website');
        $this->assign('web', $web);
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();
        $this->assign('admin', $admin);
        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('user_add', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);

        }


        return view();
    }

    public function useradds() {
        if (!session('adminuser')&&!session('adminqq')) {
            $this->error('未登录');
        }
        $data['username'] = input('post.username', '', 'htmlspecialchars');
        $userpwd = input('post.userpwd', '', 'htmlspecialchars');
        $data['userpwd'] = password_hash($userpwd, PASSWORD_DEFAULT);
        $data['useremail'] = input('post.useremail', '', 'htmlspecialchars');
        $data['userqq'] = input('post.userqq', '', 'htmlspecialchars');
        $data['userphone'] = input('post.userphone', '', 'htmlspecialchars');
        $admin = Db::table('admin')->where(array('adminuser' => session('adminuser')))->find();

        $permission = json_decode($admin['permission'], true);
        if ($admin['id'] != 1 && !in_array('user_add', $permission)) {
            $this->error('没有权限', url('/index/index')->build(), 3);
        }

        $web = Config::get('website');
        $userdata = Db::table('user')->where(array('username' => $data['username']))->find();
        if (!empty($userdata)) {
            $this->error('用户已存在');
        }
        if (!Db::table('user')->insert($data)) {
            $this->error('添加失败，未知错误。');
        }
        $this->success('添加成功');
    }

    public function logins() {

        $adminuser = input('post.adminuser', '', 'htmlspecialchars');
        $adminpwd = input('post.adminpwd', '', 'htmlspecialchars');
        $code = input('get.code', '', 'htmlspecialchars');

        $state = input('get.state', '', 'htmlspecialchars');

        $qrcodetype = input('qrcodetype');
        //登录
       if (!empty($qrcodetype)) {
            switch ($qrcodetype) {
                // 获取QQ登录二维码
                case 'getQQLoginQrcode':
                    // 获取二维码信息
                    list($status, $info) = (new QqQrcodeLogin())->getQrcodeUrl();

                    if ($status) {
                        session('qrobot_login', $info['qrsig']);
                        return Json::success()->data($info)->res();
                    }

                    return Json::error($info)->res();
                    break;
                // 获取QQ登录状态
                case 'getQQLoginStatus':
                    // 查询sign
                    $qrsig = (string)session('qrobot_login');

                    if (empty($qrsig)) {
                        return Json::error('请先获取二维码')->res();
                    }

                    list($status, $info) = (new QqQrcodeLogin())->queryStatus($qrsig);

                    // 查询失败
                    if (!$status) {
                        return Json::error($info)->res();
                    }

                    // 登录完成
                    if ($info['code'] === 3) {
                        // QQ号
                        $qq = $info['msg'];
                        // 获取用户信息
                        $data = Db::table('admin')->where(array('adminqq' => $qq))->find();
                        if (empty($data)) {
                            $info['code'] = 4;
                            $info['msg'] = '该QQ未绑定';
                        }
                        $ip = ip();
                        $adminloginip['adminloginip'] = $ip;

                        Db::table('admin')->where(array('adminuser' => $data['adminuser']))->update($adminloginip);
                        session('adminuser', $data['adminuser']);
                        session('adminqq', $data['adminqq']);

                    }

                    if (in_array($info['code'], [3, -1])) {
                        session('qrobot_login', null);
                    }

                    return Json::success()->data($info)->res();
                    break;
            }
        } elseif ($code) {

            if (session('adminuser') && session('adminqq')) {
                $this->error('您已登录!', url('/index/index')->build(), 3);
            }

            if ($state != session('state')) {
                $this->error('状态码错误!', url('/index/login')->build(), 3);
            }

            $data = Db::table('admin')->where(array('qqopenid' => $code))->find();

            if (empty($data)) {
                $this->error('该QQ未绑定', url('/index/login')->build(), 3);
            }
            $ip = ip();
            $adminloginip['adminloginip'] = $ip;

            Db::table('admin')->where(array('adminuser' => $data['adminuser']))->update($adminloginip);
            session('adminuser', $data['adminuser']);
            session('adminqq', $data['adminqq']);
            $this->success('登录成功!', url('/index/index')->build(), 3);
        }
        $admindata = Db::table('admin')->where(array('adminuser' => $adminuser))->find();
        if (empty($admindata)) {
            $this->error('管理员不存在');
        }
        if (!password_verify($adminpwd, $admindata['adminpwd'])) {
            $this->error('密码错误');
        }

        $ip = ip();
        $adminloginip['adminloginip'] = $ip;

        Db::table('admin')->where(array('adminuser' => $adminuser))->update($adminloginip);
        session('adminuser', $adminuser);
        session('adminqq', $admindata['adminqq']);
        $this->success('登录成功，请稍后...');
    }

}