<?php

namespace app\admin\library;
use think\facade\Db;
use think\facade\Config;
use app\common\library\Epanel;
use app\common\library\Btpanel;
use app\common\library\Auth;
use app\common\library\Pub;
class Host
{
    public static function createhost($data) {

        $ip = $data['apiip'];
        $apidata = Db::table('api')->where(array('apiip' => $ip))->find();
        unset($data['apiip']);
        if ($apidata['self'] == 1) {
            if ($apidata['type'] == 'bt') {
                $panel = new Btpanel($apidata['apiurl'], (new Auth)->decrypt($apidata['apikey']));
                if ($apidata['os'] == 'linux') {
                    $apistate = $panel->get_server_status('linux');
                } else {
                    $apistate = $panel->get_server_status('win');
                }
            } else {
                $panel = new Epanel($apidata['apiurl'], (new Auth)->decrypt($apidata['apikey']));
                $apistate = $panel ->test();
            }
            if ($apistate == false)return ['code' => '0',
                'msg' => '服务器通讯异常'];
        }


        $data['log_file'] = '1';
        $data['htaccess'] = '1';
        $data['access'] = '1';
        $data['subdir'] = 'wwwroot';
        if ($apidata['self'] == 0) {
            $url = $apidata['apiurl'].'Index/createhost.html';
            $postdata = array(
                'username' => $apidata['apiusername'],
                'userkey' => (new Auth)->decrypt($apidata['apikey']),
                'apiip' => $apidata['apiip'],
                'hostname' => $data['name'],
                'hostpwd' => $data['passwd'],
                'hostlimit' => $data['web_quota'],
                'dblimit' => $data['db_quota'],
                'domainlimit' => $data['domain'],
                'dirlimit' => $data['max_subdir'],
                'flowlimit' => $data['flow_limit'],
                'web_back_num' => $data['web_back_num'],
                'sql_back_num' => $data['sql_back_num'],
                'subdirflag' => $data['subdir_flag'],
                'hosttype' => $data['cdn'],
                'prot' => $data['port'],
            );
            $resultdata = Pub::request_post($url, $postdata);
            $resultdata = json_decode($resultdata, TRUE);
            if ($resultdata['status'] != 1)return ['code' => '0',
                'msg' => '1:开通失败'];
        } else {
            $resultdata = $panel->createSite($data, $apidata['apiip']);

            if ($resultdata['result'] != 200)return ['code' => '0',
                'msg' => '开通失败'];
        }
        $hostdata['hostip'] = $apidata['apiip'];
        $hostdata['kzurl'] = $apidata['kzurl'];
        $hostdata['hostname'] = $data['name'];
        $hostdata['hostpwd'] = $data['passwd'];
        $hostdata['hostwebsize'] = $data['web_quota'];
        $hostdata['hostdbsize'] = $data['db_quota'];
        Db::table('host')->insert($hostdata);
        return ['code' => '1',
            'msg' => '开通成功'];
    }
}