<?php
declare (strict_types = 1);

namespace app\api\controller;
use app\common\controller\Json;
use app\common\library\Epanel;
use app\common\library\Auth;
use app\common\library\Pub;
use think\facade\Db;
use think\facade\Request;
use app\common\library\Btpanel;
use think\facade\Config;
use app\BaseController;

class Index extends BaseController
{
    public function initialize() {
        parent::initialize();
        $this->web = Config::get('website');
        if (!isset(Config::get('website')['status']))exitContent(Json::error('目前网站维护，无法调用api')->res());
        $this->username = input('username');
        if (empty($this->username))exitContent(Json::error('用户名不得为空')->res());
        $this->userkey = input('userkey');
        $this->userdata = Db::table('user')->where(array('username' => $this->username))->find();
        if (empty($this->userdata))exitContent(Json::error('用户不存在')->res());
        if ($this->userdata['userkey'] != $this->userkey)exitContent(Json::error('密匙错误')->res());
        if ($this->userdata['userstate'] == 0)exitContent(Json::error('账号封禁')->res());
        if ($this->web['safeip'] == 1 && ip() != $this->userdata['safeip']) {

            exitContent(Json::error('IP鉴权失败')->res());
        }
        if (input('apiip') != '127.0.0.1') {
            if (empty(input('apiip')))exitContent(Json::error('接口IP缺失')->res());
            $this->apidata = Db::table('api')->where(array('apiip' => input('apiip')))->find();
            if (empty($this->apidata)) exitContent(Json::error('平台不存在该接口')->res());
            $this->apidatas = Db::table('apib')->where(array('apiip' => $this->apidata['apiip'], 'username' => $this->username))->find();
            if (empty($this->apidatas))exitContent(Json::error('未拥有该接口')->res());
            if ($this->apidata['self'] == 0) {
                $url = $this->apidata['apiurl'].'Index/checkapi.html';
                $postdata = array(
                    'username' => $this->apidata['apiusername'],
                    'userkey' => (new Auth)->decrypt($this->apidata['apikey']),
                    'apiip' => $this->apidata['apiip']
                );
                $resultdata = Pub::request_post($url, $postdata);
                $resultdata = json_decode($resultdata, TRUE);
                if ($resultdata['status'] != 1)exitContent(Json::error('接口通讯失败')->res());
            } else {
                if ($this->apidata['type'] == 'bt') {
                    $auth_cofig = Config::get('auth');
                    $auth = new Auth();
                    $auth_dekey = $auth->decode(session('authcode'. md5($auth_cofig['auth_id'])));
                    if (substr($auth_dekey, -7) != '1_lhost') {
                        exitContent(Json::error('当前版本不支持该功能')->res());
                    }
                    $this->panel = new Btpanel($this->apidata['apiurl'], (new Auth)->decrypt($this->apidata['apikey']));
                    if ($this->apidata['os'] == 'linux') {
                        $apistate = $this->panel->get_server_status('linux');
                    } else {
                        $apistate = $this->panel->get_server_status('win');
                    }
                } else {
                    $this->panel = new Epanel($this->apidata['apiurl'], (new Auth)->decrypt($this->apidata['apikey']));
                    $apistate = $this->panel ->test();
                }
                if ($apistate == false) {
                    exitContent(Json::error('接口通讯失败')->res());
                }
            }

            if (!$this->apidatas['isshow'])exitContent(Json::error('接口使用状态异常')->res());
            if ($this->apidata['cert'] == '1' && $this->userdata['cert'] == '0') {
                exitContent(Json::error('当前接口需要实名')->res());
            }
        }

    }
    public function checkapi() {

        return Json::success('接口通讯正常')->res();
    }
    public function createhost() {



        if ($this->apidata['apiusemoney'] > 0 && $this->apidata['apiusemoney'] > $this->userdata['usermoney'])return Json::error('用户余额不足')->res();
        if (input('hostlimit') > $this->apidata['apimixweb'])return Json::error('空间最大：' . $this->apidata['apimixweb'] . ' MB')->res();
        if (input('dblimit') > $this->apidata['apimixdb'])return Json::error('数据库最大' . $this->apidata['apimixdb'] . ' MB')->res();
        if (input('flowlimit') > $this->apidata['apimixflow'])return Json::error('流量最大' . $this->apidata['apimixflow'] . ' GB')->res();
        if ($this->apidata['apiusemoney'] > 0) {

            if (empty($this->userdata['grade'])) {
                $gradeyh = 10/ 10;
            } else {
                $usergrade = Db::table('grade')->where(array('id' => $this->userdata['grade']))->find();
                $gradeyh = $usergrade['yh']/ 10;
            }
            $userup['usermoney'] = $this->userdata['usermoney'] - ($this->apidatas['apiusemoney']*$gradeyh);
            if ($userup['usermoney'] < 0) {
                return Json::error('服务商的余额不足')->res();
            }

        }
        $data = array(
            "name" => input('hostname'),
            "passwd" => input('hostpwd'),
            'web_quota' => input('hostlimit'),
            'db_quota' => input('dblimit'),
            'vhost_domains' => input('hostdomain'),
            'domain' => input('domainlimit'),
            'max_subdir' => input('dirlimit'),
            'flow_limit' => input('flowlimit'),
            'subdir_flag' => input('subdirflag'),
            'web_back_num' => input('web_back_num'),
            'sql_back_num' => input('sql_back_num'),
            'ftp' => '1',
            'max_connect' => '0',
            'speed_limit' => '0',
            'db_type' => 'mysql',
            'module' => 'php',
            'max_worker' => '0',
            'subdir' => 'wwwroot',
            'log_file' => '1',
            'htaccess' => '1',
            'access' => '1',
            'cdn' => input('hosttype'),
            'port' => input('port')
        );

        if ($this->apidata['self'] == 0) {
            $url = $this->apidata['apiurl'].'Index/createhost.html';
            $postdata = array(
                'username' => $this->apidata['apiusername'],
                'userkey' => (new Auth)->decrypt($this->apidata['apikey']),
                'apiip' => $this->apidata['apiip'],
                'hostname' => $data['name'],
                'hostpwd' => $data['passwd'],
                'hostlimit' => $data['web_quota'],
                'dblimit' => $data['db_quota'],
                'domainlimit' => $data['domain'],
                'dirlimit' => $data['max_subdir'],
                'flowlimit' => $data['flow_limit'],
                'hosttype' => $data['cdn'],
                'subdirflag' => $data['subdir_flag'],
                'web_back_num' => $data['web_back_num'],
                'sql_back_num' => $data['sql_back_num'],
                'port' => $data['port']
            );
            $resultdata = Pub::request_post($url, $postdata);
            $resultdata = json_decode($resultdata, TRUE);
            if ($resultdata['status'] != 1)return Json::error('1:开通失败')->res();
        } else {
            if ($this->apidata['type'] == 'ep') {
                $apiinfo = $this->panel ->info();

                if (is_array($apiinfo) && !$this->web['isapisuper']) {
                    $apisize = Pub::disksizemb($apiinfo['disk_free']);
                    $hostsize = Db::table('host')->where(array('hostip' => $this->apidata['apiip']))->sum('hostwebsize');
                    $dbsize = Db::table('host')->where(array('hostip' => $this->apidata['apiip']))->sum('hostdbsize');
                    $hostlimit = empty(input('hostlimit'))?0:input('hostlimit');
                    $dblimit = empty(input('dblimit'))?0:input('dblimit');
                    $allsize = $hostsize+$dbsize+$hostlimit+$dblimit;
                    if ($allsize > $apisize)return Json::error('接口储存空间不足'.$apiinfo['disk_free'])->res();
                }
            }
            $resultdata = $this->panel ->createSite($data, $this->apidata['apiip']);
            if ($resultdata['result'] != 200)return Json::error('开通失败')->res();
        }
        if ($this->apidata['apiusemoney'] > 0) {
            Db::table('user')->where(array('username' => $this->userdata['username']))->update($userup);
        }
        $hostdata['hostip'] = $this->apidata['apiip'];
        $hostdata['hostname'] = input('hostname');
        $hostdata['hostpwd'] = input('hostpwd');
        $hostdata['hostwebsize'] = input('hostlimit');
        $hostdata['hostdbsize'] = input('dblimit');
        $hostdata['username'] = $this->username;
        $hostdata['kzurl'] = $this->apidata['kzurl'];
        Db::table('host')->insert($hostdata);
        Db::table('apib')->where(array('apiip' => $this->apidata['apiip'], 'username' => $this->username))->update(['use' => $this->apidatas['use'] + 1]);
        Db::table('api')->where(array('apiip' => $this->apidata['apiip']))->update(['apiuse' => $this->apidata['apiuse'] + 1]);
        return Json::success('开通成功')->res();
    }
    public function updatehost() {
        $hostlimit = input('hostlimit');
        $hostname = input('hostname');
        $dblimit = input('dblimit');
        $flowlimit = input('flowlimit');
        $subdirflag = input('subdirflag');
        $dirlimit = input('dirlimit');
        $domainlimit = input('domainlimit');
        $web_back_num = input('web_back_num');
        $sql_back_num = input('sql_back_num');
        $port = input('port');
        if (empty($hostname)) {
            return Json::error('hostname缺失')->res();
        }
        if ($this->apidata['type'] == 'bt') {
            $data['name'] = $hostname;
            if (!empty($hostlimit)) {
                $data['web_quota'] = $hostlimit;
                $hostdata['web_size'] = $hostlimit;
            }
            if (!empty($dblimit)) {
                $data['db_quota'] = $dblimit;
                $hostdata['sql_size'] = $dblimit;
            }
            if (!empty($flowlimit)) $data['flow_size'] = $flowlimit;
            if (!empty($subdirflag)) $data['is_dir'] = $subdirflag;
            if (!empty($dirlimit))$data['dir_num'] = $dirlimit;
            if (!empty($domainlimit))$data['domain_num'] = $domainlimit;
            if (!empty($web_back_num))$data['web_back_num'] = $web_back_num;
            if (!empty($sql_back_num))$data['sql_back_num'] = $sql_back_num;
        } else {
            $data['name'] = $hostname;
            if (!empty($hostlimit)) {
                $data['web_quota'] = $hostlimit;
                $hostdata['hostwebsize'] = $hostlimit;
            }
            if (!empty($dblimit)) {
                $data['db_quota'] = $dblimit;
                $hostdata['hostdbsize'] = $dblimit;
            }
            if (!empty($flowlimit)) $data['flow_limit'] = $flowlimit;
            if (!empty($subdirflag)) $data['subdir_flag'] = $subdirflag;
            if (!empty($port))$data['port'] = $port;
            if (!empty($dirlimit))$data['max_subdir'] = $dirlimit;
            if (!empty($domainlimit))$data['domain'] = $domainlimit;
            $data['edit'] = '1';
        }
        if ($this->apidata['self'] == 0) {
            $url = $this->apidata['apiurl'].'Index/updatehost.html';
            $postdata = array(
                'username' => $this->apidata['apiusername'],
                'userkey' => (new Auth)->decrypt($this->apidata['apikey']),
                'apiip' => $this->apidata['apiip'],
                'hostname' => $hostname,
                'hostlimit' => $hostlimit,
                'dblimit' => $dblimit,
                'flowlimit' => $flowlimit,
                'subdirflag' => $subdirflag,
                'port' => $port,
                'dirlimit' => $dirlimit,
                'domainlimit' => $domainlimit
            );
            $resultdata = Pub::request_post($url, $postdata);
            $resultdata = json_decode($resultdata, TRUE);
            if ($resultdata['status'] != 1)return Json::error('1:修改失败')->res();
        } else {
            if ($this->apidata['type'] == 'bt') {
                $resultdata = $this->panel ->updatehost($data);
            } else {
                $resultdata = $this->panel ->createSite($data);
            }
            if ($resultdata['result'] != 200)return Json::error('修改失败')->res();
        }

        if (!empty($hostlimit)||!empty($dblimit)) Db::table('host')->where(array('hostname' => $hostname, 'hostip' => $this->apidata['apiip']))->update($hostdata);
        return Json::success('修改成功')->res();
    }
    public function updatepassword() {
        $hostname = input('hostname');
        $hostpwd = input('hostpwd');

        if ($this->apidata['self'] == 0) {
            $url = $this->apidata['apiurl'].'Index/updatepassword.html';
            $postdata = array(
                'username' => $this->apidata['apiusername'],
                'userkey' => (new Auth)->decrypt($this->apidata['apikey']),
                'apiip' => $this->apidata['apiip'],
                'hostname' => $hostname,
                'hostpwd' => $hostpwd
            );
            $resultdata = Pub::request_post($url, $postdata);
            $resultdata = json_decode($resultdata, TRUE);
            if ($resultdata['status'] != 1)return Json::error('1:修改失败')->res();
        } else {
            $resultdata = $this->panel ->changepwd($hostname, $hostpwd);

            if ($resultdata['result'] != 200)return Json::error('修改失败')->res();
        }

        Db::table('host')->where(array('hostname' => $hostname, 'hostip' => $this->apidata['apiip']))->update(['hostpwd' => $hostpwd]);
        return Json::success('修改成功')->res();
    }
    public function delhost() {
        $hostname = input('hostname');

        if ($this->apidata['self'] == 0) {
            $url = $this->apidata['apiurl'].'Index/delhost.html';
            $postdata = array(
                'username' => $this->apidata['apiusername'],
                'userkey' => (new Auth)->decrypt($this->apidata['apikey']),
                'apiip' => $this->apidata['apiip'],
                'hostname' => $hostname
            );
            $resultdata = Pub::request_post($url, $postdata);
            $resultdata = json_decode($resultdata, TRUE);
            if ($resultdata['status'] != 1)return Json::error('1:删除失败')->res();
        } else {
            $resultdata = $this->panel ->delSite($hostname);

            if ($resultdata['result'] != 200)return Json::error('删除失败'.$resultdata['msg'])->res();
        }

        Db::table('host')->where(array('hostname' => $hostname, 'hostip' => $this->apidata['apiip']))->delete();
        return Json::success('删除成功')->res();
    }
    public function updatestatus() {
        $hostname = input('hostname');
        $status = input('status');
        if ($this->apidata['self'] == 0) {
            $url = $this->apidata['apiurl'].'Index/updatestatus.html';
            $postdata = array(
                'username' => $this->apidata['apiusername'],
                'userkey' => (new Auth)->decrypt($this->apidata['apikey']),
                'apiip' => $this->apidata['apiip'],
                'hostname' => $hostname,
                'status' => $status
            );
            $resultdata = Pub::request_post($url, $postdata);
            $resultdata = json_decode($resultdata, TRUE);
            if ($resultdata['status'] != 1)return Json::error('1:修改失败')->res();
        } else {
            $resultdata = $this->panel ->changeStatus($hostname, $status);

            if ($resultdata['result'] != 200)return Json::error('修改失败')->res();
        }

        Db::table('host')->where(array('hostname' => $hostname, 'hostip' => $this->apidata['apiip']))->update(['hoststate' => $status]);
        return Json::success('修改成功')->res();
    }
    public function get_kzurl() {
        return Json::success('获取成功')->data($this->apidata['kzurl'])->res();
    }
    public function apilist() {
        $apilist = Db::table('apib')->where(array('username' => $this->username))->select();
        if (empty($apilist))return Json::error('获取失败')->res();
        foreach ($apilist as $value) {
            $api = Db::table('api')->where(array('apiip' => $value['apiip']))->find();
            $apidata[$value['apiip']]['apiip'] = $api['apiip'];
            $apidata[$value['apiip']]['apiname'] = $api['apiname'];
            $apidata[$value['apiip']]['apimoney'] = $api['apimoney'];
            $apidata[$value['apiip']]['apiusemoney'] = $api['apiusemoney'];
            $apidata[$value['apiip']]['apimixweb'] = $api['apimixweb'];
            $apidata[$value['apiip']]['apimixdb'] = $api['apimixdb'];
            $apidata[$value['apiip']]['apimixflow'] = $api['apimixflow'];
            $apidata[$value['apiip']]['kzurl'] = $api['kzurl'];
            $apidata[$value['apiip']]['type'] = $api['type'];
        }
        return Json::success('获取成功')->data($apidata)->res();
    }
}