<?php
declare (strict_types = 1);

namespace app\api\controller;
use app\common\library\Pub;
use think\facade\Db;
use think\facade\Config;
use app\BaseController;

class Robot extends BaseController
{
    public function initialize() {
        parent::initialize();
        $this->web = Config::get('website');
        if(Config::get('website')['status']!='on')exit('目前网站维护，无法调用api');
        if (input('robotqq') != $this->web['robotqq']) {
            exit('Robot Qq 鉴权失败');
        }
        if (input('robotkey') != $this->web['robotkey']) {
            exit('Robot Key 鉴权失败');
        }
        $this->sender = input('sender');
        $this->userdata = Db::table('user')->where(array('userqq' => $this->sender))->find();
    }
    public function reg() {
        $username = input('username');
        if (empty($username))exit('用户名不得为空');
        if ($this->userdata)exit('您所使用的QQ已经绑定,如需解绑请到用户中心取消绑定');
        $user = Db::table('user')->where(array('username' => $username))->find();
        
        if ($user)exit('用户名重复');
        $userpwd = chr(rand(97,122)).chr(rand(97,122)).chr(rand(97,122)).rand(10,1000);
        $userpwds = password_hash($userpwd, PASSWORD_DEFAULT);
        $key = Pub::GetRandStrrand(48);
        $data['username'] = $username;
        $data['userpwd'] = $userpwds;
        $data['userqq'] = $this->sender;
        $data['userkey'] = $key;
        $data['useremail'] = $this->sender.'@qq.com';
        Db::table('user')->insert($data);
        echo'注册信息已经私聊发送给您$发消息$QQ无空格$私聊您的用户名为：'.$username.'';
        echo'【换行】';
        echo'您的密码为：'.$userpwd.'';
        echo'【换行】';
        echo'您的密钥为：'.$key.'';
        echo'【换行】';
        echo'已经为您绑定qq无需绑定如需取消绑定发送：取消绑定隐藏$';
    }
    public function setkey() {
        if (empty($this->userdata))exit('你还没有绑定,请前往用户中心扫码绑定！');
        if ($this->userdata['userstate'] == 0)exit('您的账号状态为封禁');
        $key = Pub::GetRandStrrand(48);
        $data['userkey'] = $key;
        Db::table('user')->where(array('userqq' => $this->sender))->update($data);
        exit ('新的密钥已经私聊发送给您$发消息$QQ无空格$私聊您的新密钥为'.$key.'隐藏$');
    }
    public function lookkey() {
        if (empty($this->userdata))exit('你还没有绑定,请前往用户中心扫码绑定！');
        if ($this->userdata['userstate'] == 0)exit('您的账号状态为封禁');
       if (empty($this->userdata['userkey']))exit('请发送：生成密钥进行生成');
        exit('密钥已经私聊发送给您$发消息$QQ无空格$私聊您的密钥为'.$this->userdata['userkey'].'隐藏$');
    }
    public function lookmoney() {
        if (empty($this->userdata))exit('你还没有绑定,请前往用户中心扫码绑定！');
        if ($this->userdata['userstate'] == 0)exit('您的账号状态为封禁');
        exit("您的余额为：".$this->userdata['usermoney']);
    }
    public function lookmsg() {
        if (empty($this->userdata))exit('你还没有绑定,请前往用户中心扫码绑定！');
        if ($this->userdata['userstate'] == 0)exit('您的账号状态为封禁');
        exit($this->userdata['username'].'|'.$this->userdata['userkey']);
    }
    public function pay() {
        $money = input('money');
        if (empty($this->userdata))exit('你还没有绑定,请前往用户中心扫码绑定！');
        if ($this->userdata['userstate'] == 0)exit('您的账号状态为封禁');
        $data['usermoney'] = $this->userdata['usermoney']+$money;
        Db::table('user')->where(array('userqq' => $this->sender))->update($data);
        exit('充值成功,现余额为'.$data['usermoney']);
    }
    public function setpwd() {
        if (empty($this->userdata))exit('你还没有绑定,请前往用户中心扫码绑定！');
        if ($this->userdata['userstate'] == 0)exit('您的账号状态为封禁');
        $userpwd = chr(rand(97,122)).chr(rand(97,122)).chr(rand(97,122)).rand(10,1000);
        $userpwds = password_hash($userpwd, PASSWORD_DEFAULT);
        $data['userpwd'] = $userpwds;
        Db::table('user')->where(array('userqq' => $this->sender))->update($data);
        exit ('新的密码已经私聊发送给您$发消息$QQ无空格$私聊您的新密码为'.$userpwd.'隐藏$');
    }
    public function apilist() {
        $apidata = Db::table('api')->where(array('isshow' => 1))->select();
        foreach ($apidata as $value) {
            echo $value['id'].".".$value['apiname']."【换行】";
        }
    }
    public function myapi() {
        if (empty($this->userdata))exit('你还没有绑定,请前往用户中心扫码绑定！');
        if ($this->userdata['userstate'] == 0)exit('您的账号状态为封禁');
        $apidata = Db::table('apib')->where(array('username' => $this->userdata['username']))->select()->toArray();
         if (empty($apidata))exit('没有购买过接口！');
        foreach ($apidata as $value) {
            echo $value['id'].".".$value['apiname']."   ".$value['apiip']."【换行】";
        }
    }
    public function apinews() {
        $apiid = input('apiid');
        $apidata = Db::table('api')->where(array('id' => $apiid))->find();
        if (empty($apidata))exit('未查询到信息');
        if ($apidata['apistate'] == 1) {
            $apinow = '正常';
        } else {
            $apinow = '异常';
        }
        echo "￥".$apidata['apimoney']."/月";
        echo "【换行】";
        echo "￥".$apidata['apiusemoney']."/次";
        echo "【换行】";
        echo "Ip:".$apidata['apiip']."";
        echo "【换行】所有者:".$apidata['username']?$apidata['username']:'管理员'."";
        echo "【换行】";
        echo "最大空间:".$apidata['apimixweb']."";
        echo "【换行】";
        echo "最大数据库:".$apidata['apimixdb']."";
        echo "【换行】";
        echo "最大流量:".$apidata['apimixflow']."";
        echo "【换行】";
        echo "状态:".$apinow."";
    }
    public function myapinews() {
        if (empty($this->userdata))exit('你还没有绑定,请前往用户中心扫码绑定！');
        if ($this->userdata['userstate'] == 0)exit('您的账号状态为封禁');
        $apiid = input('apiid');
        $apidata = Db::table('apib')->where(array('id' => $apiid))->find();
        if (empty($apidata))exit('未查询到信息');
        if ($this->userdata['username'] != $apidata['username']) {
            exit('此接口不是您的无法查看！');
        }
        if (!$apidata['isshow']) {
            $apinow = '异常';
        } elseif ($apidata['isshow'] == 1) {
            if ($apidata['uselengthcd'] != 0) {
                $apinow = '正常';
            } else {
                $apinow = '到期';
            }
        }
        echo "接口IP:".$apidata['apiip']."";
        echo "【换行】";
        echo "接口名称:".$apidata['apiname']."";
        echo "【换行】";
        echo "接口价格:".$apidata['apimoney']."";
        echo "【换行】";
        echo "调用价格:".$apidata['apiusemoney'];
        echo "【换行】";
        echo "购买时长:".$apidata['uselength']."";
        echo "【换行】";
        echo "剩余时间:".$apidata['uselengthcd']."";
        echo "【换行】";
        echo "购买时间:".$apidata['usetime']."";
        echo "【换行】";
        echo "使用状态:".$apinow."";
    }
    public function buyapi() {
        if (empty($this->userdata))exit('你还没有绑定,请前往用户中心扫码绑定！');
        if ($this->userdata['userstate'] == 0)exit('您的账号状态为封禁');
        $id = input('id');
        $num = input('num');
        if (empty($id))exit('请输入购买产品id');
        if (empty($num))exit('请输入购买数量');
        if (!$this->web['userbuyapi']) {
            exit('管理员未开启此功能');
        }
        $apidata = Db::table('api')->where(array('id' => $id))->find();
        if (empty($apidata)) {
            exit('API不存在');
        }
        if (empty($this->userdata['grade'])) {
                    $gradeyh = 10/ 10;
                } else {
                    $usergrade = Db::table('grade')->where(array('id' => $this->userdata['grade']))->find();
                    $gradeyh = $usergrade['yh']/ 10;
        }
        $needapimoney = $apidata['apimoney']*$gradeyh;
        if ($this->userdata['usermoney'] < $needapimoney * $num) {
            exit('余额不足');
        }

        $username = $apidata['username'];
        $ip = $apidata['apiip'];
        //api的ip
        $money = $needapimoney * $num;
        //api的钱数
        $usetime = date('Y-m-d');
        //购买额日期
        $uselength = 30 * $num;
        //购买底数
        $apidatat = Db::table('apib')->where(array('apiip' => $apidata['apiip'],'username' => $this->userdata['username']))->find();
        //获取用户是否购买过同类型

        $apiname = $apidata['apiname'];
        //api名称
        $apimoney = $apidata['apimoney'];
        //api钱数
        $apiusemoney = $apidata['apiusemoney'];
        //api调用钱数
        if ($money > 0) {
            //判断金额是否大于0

            Db::table('user')->where(array('username' => $this->userdata['username']))->update(['usermoney' => $this->userdata['usermoney'] - $money]);
            if ($money >= 1) {
                //判断是否大于一好来提成
                $upticheng = $this->web['upticheng'] / 100;
                //提成比例
                $ticheng = $money * $upticheng;
                //提成金额


                $updata = Db::table('userb')->where(array('downuserid' => $this->userdata['id']))->find();
                if (!empty($updata)) {
                    //如果上级不为空
                    $upuserid = $updata['upuserid'];
                    $upuserdata = Db::table('user')->where(array('id' => $upuserid))->find();
                    Db::table('user')->where(array('id' => $upuserid))->update(['usermoney' => $upuserdata['usermoney'] + $ticheng]);
                    $updatas = Db::table('userb')->where(array('downuserid' => $updata['upuserid']))->find();
                    if (!empty($updatas)) {
                        //如果上级上级不为空

                        $upuserids = $updatas['upuserid'];
                        //上级上级id
                        $upuserdatas = Db::table('user')->where(array('id' => $upuserids))->find();
                        Db::table('user')->where(array('id' => $upuserid1))->update(['usermoney' => $upuserdatas['usermoney'] + $ticheng]);
                    }
                }
            }

        }
       
        if (empty($apidatat)) {

            Db::table('apib')->insert(['username' => $this->userdata['username'],'apiip' => $apidata['apiip'],'uselength' => $uselength,'usetime' => $usetime,'apiname' => $apiname,'apimoney' => $apimoney,'apiusemoney' => $apiusemoney,'type'=>$apidata['type']]);
        } else {
            Db::table('apib')->where(array('username' => $this->userdata['username'],'apiip' => $apidata['apiip']))->update(['uselength' => $apidatat['uselength'] + $uselength]);

        }
        $this->cron('1');
          Pub::LingduMsg('购买成功提醒！','接口IP：'.$ip.'<br/>接口余额：'.$apidata['apimoney'].'/月<br/>购买时长：'.$num.'月<br/>消费余额：'.$money.'<br/>欢迎您的下次购买！',$this->userdata['username']);
        exit('购买成功');

    }
    public function  cron($type = '0') {
        $data = Db::table('apib')->where(array('isshow' => 1))->select();
        foreach ($data as $item) {
            $goodday = $item['uselength']*24*60*60;
            $cd = round(((strtotime($item['usetime'])+$goodday)-time())/24/3600,2);
            $item_id = $item['id'];
            if ($cd <= 0) {
                $this->userdata = Db::table('user')->where(array('username' => $item['username']))->select();

                Db::table('apib')->where(array('id' => $item_id))->delete();
            }
            $cron['uselengthcd'] = $cd;
            $result = Db::table('apib')->where(array('id' => $item_id))->update($cron);
            if ($type == '0')echo "执行成功 ID:".$item_id."</br>";

        }
    }
}