<?php
namespace app\common\library;
use app\common\library\GeetestLib;
use think\facade\Db;
use think\facade\Config;
use app\user\library\Yzm;
class Pub
{
    public static function is_idcard($id) {
        $id = strtoupper($id);
        $regx = "/(^\d{17}([0-9]|X)$)/";
        $arr_split = array();
        if (strlen($id) != 18 || !preg_match($regx, $id)) {
            return false;
        }
        $regx = "/^(\d{6})+(\d{4})+(\d{2})+(\d{2})+(\d{3})([0-9]|X)$/";
        @preg_match($regx, $id, $arr_split);
        $dtm_birth = $arr_split[2] . '/' . $arr_split[3]. '/' .$arr_split[4];
        if (!strtotime($dtm_birth)) //检查生日日期是否正确
        {
            return false;
        } else
        {
            //检验18位身份证的校验码是否正确。
            //校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。
            $arr_int = array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2);
            $arr_ch = array('1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2');
            $sign = 0;
            for ($i = 0; $i < 17; $i++) {
                $b = (int) $id { $i
                }
                ;
                $w = $arr_int[$i];
                $sign += $b * $w;
            }
            $n = $sign % 11;
            $val_num = $arr_ch[$n];
            if ($val_num != substr($id,17, 1)) {
                return false;
            } else
            {
                return true;
            }
        }
    }
    public static function api($id) {
        $api = Db::table('api')->where(array('id' => $id))->find();
        if ($api['apiuse'] > Db::table('api')->avg('apiuse') && $id == Db::table('api')->max('id')) {
            return '最新 & 最热';
        } elseif ($api['apiuse'] > Db::table('api')->avg('apiuse')) {
            return '最热';
        } elseif ($id == Db::table('api')->max('id')) {
            return '最新';
        } else {
            return false;
        }
    }
    public static function get_idcard($s,$t) {
        $s=(new Auth)->decrypt($s);
        if($t=='1'){
            return showstar((strlen($s)-3)/3).substr($s,-3);
        }else{
            return substr($s,0,3).showstar(11).substr($s,-4);
        }
    }
    public static function qqLogin ($redirect) {
        $state = self::GetRandStrrand('64');
        session('state',$state);
        $url = 'http://login.nanyinet.com/qqlogin/?state=' . $state . '&redirect_uri=' . $redirect;
        return $url;
    }
    public static function get_grade_name($id) {
        if ($id == 0) {
            return '默认等级';
        }
        $grade = Db::table('grade')->where(['id' => $id])->find();
        return $grade['name'];
    }
    public static function GetRandStrrand($length) {
        $str = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
        $len = strlen($str) - 1;
        $randstr = '';
        for ($i = 0; $i < $length; $i++) {
            $num = mt_rand(0, $len);
            $randstr .= $str[$num];
        }
        return $randstr;
    }
    public static  function MsTime() {
        list($t1, $t2) = explode(' ', microtime());
        return (float)sprintf('%.0f',(floatval($t1)+floatval($t2))*1000);
    }
    public static  function bytes2mb($bytes) {
        return is_numeric($bytes) ? round($bytes / 1024 / 1024, 2) : 0;
    }
    public static function toBytes($size) {

        if (strstr($size, 'TB')) {
            $str = str_replace('TB', '', $size);
            $s = $str * 1024 * 1024 * 1024 * 1024;
        } elseif (strstr($size, 'GB')) {
            $str = str_replace('GB', '', $size);
            $s = $str * 1024 * 1024 * 1024;
        } elseif (strstr($size, 'MB')) {
            $str = str_replace('MB', '', $size);
            $s = $str * 1024 * 1024;
        } elseif (strstr($size, 'KB')) {
            $str = str_replace('KB', '', $size);
            $s = $str * 1024;
        } elseif (strstr($size, 'b')) {
            $str = str_replace('b', '', $size);
            $s = $str;
        } else {
            $s = $size;
        }
        return  $s;
    }
    public static function LingduMsg ($title,$content,$username) {
        $user = Db::table('user')->where(array('username' => $username))->find();
        if (!empty($user['wxopenid'])) {
            self::request_post('http://nanyinet.com/wx/mbone',['url' => request()->domain(),'title' => $title,'openid' => $user['wxopenid'],'content' => $content]);
        }
        if (!empty($user['useremail'])) {
            Yzm::sendemsmsg($user['useremail'],$content,$title);
        } elseif (empty($user['useremail'])&&!empty($user['userqq'])) {
            Yzm::sendemsmsg($user['userqq'].'@qq.com',$content,$title);
        }

    }

    public static function LingduMsgs ($title,$content) {
        $admin = Db::table('admin')->where(array('id' => 1))->find();
        if (!empty($admin['adminwxs'])) {
            self::request_post('http://nanyinet.com/wx/mbone',['url' => request()->domain(),'title' => $title,'openid' => $admin['adminwxs'],'content' => $content]);
        }
        if (!empty($admin['adminqq'])) {
            Yzm::sendemsmsg($admin['adminqq'].'@qq.com',$content,$title);
        }
    }

    public static function getCity($ip) {
        $getIp = $ip;
        $content = self::curl_request("http://api.map.baidu.com/location/ip?ak=YWNt8VcHK7Goj1yljLlMVHnWl6ZWS26t&ip={$getIp}&coor=bd09ll");
        $json = json_decode($content,true);
        return $json['content']['address'];

    }


    public static function getRequestTimes($url, $timeout = 60) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_exec($ch);
        $request = curl_getinfo($ch);
        curl_close($ch);
        return isset($request['total_time']) ? $request['total_time'] : false;
    }
    public static function getFolderList($path) {
        $folderList = [];
        //最终返回的数组
        $keysValue = [];
        //二维数组需要排序的值
        //扫描目录内的所有目录和文件并返回数组
        $data = scandir($path);
        $k = 0;
        foreach ($data as $value) {
            //判断如果不是文件夹则进入下一次循环
            if (!is_dir($path . "/" . $value)) {
                continue;
            }
            if ($value != '.' && $value != '..') {
                $folderList[$k] = array(
                    "name" => $value,
                );
                $keysValue[$k] = $value;
                //记录排序值
                $k++;
            }
        }
        //对二维数组进行排序
        array_multisort($keysValue, SORT_DESC, $folderList);
        return $folderList;
    }
    public static function is_mobile() {

        $user_agent = strtolower($_SERVER['HTTP_USER_AGENT']);

        $mobile_agents = array("ipad", "wap", "android", "iphone", "sec", "sam", "ericsson", "240x320", "acer", "acoon", "acs-", "abacho", "ahong", "airness", "alcatel", "amoi", "anywhereyougo.com", "applewebkit/525", "applewebkit/532", "asus", "audio", "au-mic", "avantogo", "becker", "benq", "bilbo", "bird", "blackberry", "blazer", "bleu", "cdm-", "compal", "coolpad", "danger", "dbtel", "dopod", "elaine", "eric", "etouch", "fly ", "fly_", "fly-", "go.web", "goodaccess", "gradiente", "grundig", "haier", "hedy", "hitachi", "htc", "huawei", "hutchison", "inno", "ipaq", "ipod", "jbrowser", "kddi", "kgt", "kwc", "lenovo", "lg", "lg2", "lg3", "lg4", "lg5", "lg7", "lg8", "lg9", "lg-", "lge-", "lge9", "longcos", "maemo", "mercator", "meridian", "micromax", "midp", "mini", "mitsu", "mmm", "mmp", "mobi", "mot-", "moto", "nec-", "netfront", "newgen", "nexian", "nf-browser", "nintendo", "nitro", "nokia", "nook", "novarra", "obigo", "palm", "panasonic", "pantech", "philips", "phone", "pg-", "playstation", "pocket", "pt-", "qc-", "qtek", "rover", "sagem", "sama", "samu", "sanyo", "samsung", "sch-", "scooter", "sec-", "sendo", "sgh-", "sharp", "siemens", "sie-", "softbank", "sony", "spice", "sprint", "spv", "symbian", "tcl-", "teleca", "telit", "tianyu", "tim-", "toshiba", "tsm", "up.browser", "utec", "utstar", "verykool", "virgin", "vk-", "voda", "voxtel", "vx", "wellco", "wig browser", "wii", "windows ce", "wireless", "xda", "xde", "zte", "ben", "hai", "phili");

        $is_mobile = false;

        foreach ($mobile_agents as $device) {

            if (stristr($user_agent, $device)) {

                $is_mobile = true;

                break;

            }

        }

        return $is_mobile;

    }



    public static function request_post($url = '', $post_data = array()) {
        if (empty($url) || empty($post_data)) {
            return false;
        }
        $o = "";
        foreach ($post_data as $k => $v) {
            $o.= "$k=" . urlencode($v). "&" ;
        }
        $post_data = substr($o,0,-1);
        $postUrl = $url;
        $curlPost = $post_data;
        $ch = curl_init();
        //初始化curl
        curl_setopt($ch, CURLOPT_URL,$postUrl);
        //抓取指定网页
        curl_setopt($ch, CURLOPT_HEADER, 0);
        //设置header
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        //要求结果为字符串且输出到屏幕上
        curl_setopt($ch, CURLOPT_POST, 1);
        //post提交方式
        curl_setopt($ch, CURLOPT_POSTFIELDS, $curlPost);
        $data = curl_exec($ch);
        //运行curl
        curl_close($ch);
        return $data;
    }
    public static function curl_request($url, $post = '', $referer = '', $cookie = '', $returnCookie = 0, $ua = 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:43.0) Gecko/20100101 Firefox/43.0') {
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_USERAGENT, $ua);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($curl, CURLOPT_AUTOREFERER, 1);
        curl_setopt($curl, CURLOPT_TIMEOUT, 60);
        curl_setopt($curl, CURLOPT_REFERER, $referer);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        $httpheader[] = "text/html,application/xhtml+xml,application/xml;q=0.9,image/webp,image/apng,*/*;q=0.8";
        $httpheader[] = "Accept-Encoding:gzip, deflate";
        $httpheader[] = "Accept-Language:zh-CN,zh;q=0.9";
        $httpheader[] = "Connection:close";
        curl_setopt($curl, CURLOPT_HTTPHEADER, $httpheader);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
        if ($post) {
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($post));
        }
        if ($cookie) {
            curl_setopt($curl, CURLOPT_COOKIE, $cookie);
        }
        curl_setopt($curl, CURLOPT_HEADER, $returnCookie);
        curl_setopt($curl, CURLOPT_TIMEOUT, 10);
        curl_setopt($curl, CURLOPT_ENCODING, "gzip");
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        $data = curl_exec($curl);
        if (curl_errno($curl)) {
            return curl_error($curl);
        }
        curl_close($curl);
        if ($returnCookie) {
            list($header, $body) = explode("\r\n\r\n", $data, 2);
            preg_match_all("/Set\-Cookie:([^;]*);/", $header, $matches);
            $info['cookie'] = substr($matches[1][1], 1);
            $info['content'] = $body;
            return $info;
        } else {
            return $data;
        }
    }

    public static function error_write_log($message) {

        $log = fopen(app()->getRootPath()  . 'log/error.log', 'a');
        if ($log) {
            $message = date('[Y-m-d H:i:s] ') . $message . "\r\n";
            fputs($log, $message);
            fclose($log);
            return true;
        } else {
            return false;
        }
    }

    public static function getRandStr($len = 16,$type = 1) {
        $str = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
        $strlen = strlen($str);
        $randstr = '';
        for ($i = 0; $i < $len; $i++) {
            $randstr .= $str[mt_rand(0, $strlen - 1)];
        }
        if ($type == 1) {
            $randstr = strtoupper($randstr);
        } elseif ($type == 2) {
            $randstr = strtolower($randstr);
        }
        return $randstr;
    }


    public static function geetest_chcek_verify($geetest_id,$geetest_key,$geetest_challenge, $geetest_validate, $geetest_seccode) {
        $geetest = new GeetestLib($geetest_id,$geetest_key);
        $user_id = session('geetest_user_id');
        $ip_address = session('geetest_user_id');
        $data = array(
            "user_id" => $user_id, # 网站用户id
            "client_type" => "web", #web:电脑上的浏览器；h5:手机上的浏览器，包括移动应用内完全内置的web_view；native：通过原生SDK植入APP应用的方式
            "ip_address" => $ip_address, # 请在此处传输用户请求验证时所携带的IP
        );
        if (session('geetest_status') == 1) {
            $result = $geetest->success_validate($geetest_challenge,$geetest_validate, $geetest_seccode, $data);
            if ($result) {
                return true;
            } else {
                return false;
            }
        } else {
            if ($geetest->fail_validate($geetest_challenge,$geetest_validate, $geetest_seccode)) {
                return true;
            } else {
                return false;
            }
        }
    }


    public static function check_mail($mail) {
        $checkmail = "/\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*/";
        //定义正则表达式
        if (preg_match($checkmail, $mail)) {
            return true;
        } else {
            return false;
        }
    }



    public static function random_str () {
        $poems = "primary|success|info|warning|danger|purple|cyan|brown";
        $poems = explode("|",$poems);
        return $poems[rand(0,count($poems)-1)];
    }


    public static function fun_adm_each(&$array) {
        $res = array();
        $key = key($array);
        if ($key !== null) {
            next($array);
            $res[1] = $res['value'] = $array[$key];
            $res[0] = $res['key'] = $key;
        } else {
            $res = false;
        }
        return $res;
    }


    public static function diskSizeMb($num) {
        return intval($num/1024/1024);
    }

}