<?php
declare (strict_types = 1);

namespace app\host\command;

use app\common\library\Pub;
use app\common\library\Btpanel;
use think\facade\Db;
use app\common\library\Auth;
use think\console\Command;
use think\console\Input;
use think\console\input\Argument;
use think\console\input\Option;
use think\console\Output;

class Host extends Command
{
    protected function configure()
    {
        // 指令配置
        $this->setName('cron')
            ->setDescription('the cron command');
    }

    protected function execute(Input $input, Output $output)
    {
       
          $host = Db::table('bt_host')->where(['web_status' => '1'])->select();
        foreach ($host as $v) {
            $server = Db::table('api')->where(array('type' => 'bt','apiip' => $v['server']))->find();
            $Btpanel = new Btpanel($server['apiurl'],(new Auth)->decrypt($server['apikey']));
            // 流量
            $Total = json_decode($Btpanel->send('GetTotal'),true);
            if ($Total && isset($Total['open']) && $Total['open'] == 'true') {
                $total_size = $Btpanel->get_NetNumber_month($v['domain']);
                if (!$total_size || !isset($total_size['total_size'])) {
                    $total_size['total_size'] = 0;
                }
            } else {
                $total_size['total_size'] = 0;
            }
            // 实际使用流量
            $total_size_s = is_numeric($total_size['total_size']) ? Pub::bytes2mb($total_size['total_size']) : 0;
            if ($v['flow_size'] != '0' && $total_size_s > $v['flow_size']) {

                $Btpanel->send('WebSiteStop',['id' => $v['web_id'],'name' => $v['domain']]);
                 $output->writeln($v['web_id']."流量使用超出限制，已暂停\n");
                Db::table('bt_host')->where('id', $v['id'])->update([
                    'web_status' => '0',
                ]);
            }

            // 空间大小
            $websize = Pub::bytes2mb(json_decode($Btpanel->send('GetWebSize',['path' => $v['path']]),true)['size']);
            if ($v['web_size'] != '0' && $websize > $v['web_size']) {
                $Btpanel->send('WebSiteStop',['id' => $v['web_id'],'name' => $v['domain']]);
                 $output->writeln($v['web_id']."空间使用超出限制，已暂停\n");
                Db::table('bt_host')->where('id', $v['id'])->update([
                    'web_status' => '0',
                ]);
            }

            // 数据库大小
            if (isset($v['sql_name']) && $v['sql_name']) {
                $sqlsize = Pub::bytes2mb($Btpanel->get_sql_sizes($v['sql_name']));
                if ($v['sql_size'] != '0' && $sqlsize > $v['sql_size']) {
                    $Btpanel->send('WebSiteStop',['id' => $v['web_id'],'name' => $v['domain']]);
                     $output->writeln($v['web_id']."数据库使用超出限制，已暂停\n");
                    Db::table('bt_host')->where('id', $v['id'])->update([
                        'web_status' => '0',
                    ]);
                }
            }
             $output->writeln($v['web_id']."------操作执行完毕-----\n");
           sleep(1);
        }
    }
}
