<?php
declare (strict_types = 1);

namespace app\index\controller;
use app\common\library\Pub;
use think\facade\Db;
use think\facade\Config;
use app\BaseController;

class Index extends BaseController
{
    public function initialize() {
       parent::initialize();
       $web=Config::get('website');
       if(!isset($web['status']))exitContent(view(config('app.maintain_tmpl'), ['webqq'=>$web['webqq'],'webname'=>$web['webname'],'cdn'=>$web['cdn']]));
    }
    public function index() {
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        //统计网站
        $this->assign('api',Db::table('api')->count());
        $this->assign('useapi',Db::table('api')->where(array('apistate' => 1))->count());
        $this->assign('usesum',Db::table('api')->sum('apiuse'));
        $this->assign('user',Db::table('user')->count());
        $this->assign('apidata',Db::table('api')->where(array('isshow' => 1))->select());
        //引入网站模板文件
        return view($web['index_template'].'/index');
    }
    public function clear() {
        if (delete_dir_file(app()->getRootPath()  . 'runtime')) {
            $this->success('清除缓存成功');
        } else {
            $this->error('清除缓存失败');
        }
    }
}