<?php
declare (strict_types = 1);

namespace app\user\controller;
use app\user\controller\F2fpay;
use app\user\library\EPay;
use app\user\library\Host;
use app\user\library\Yzm;
use app\user\library\CodePay;
use app\common\controller\Json;
use app\common\library\Pub;
use app\common\library\Btpanel;
use app\common\library\Epanel;
use app\common\library\GeetestLib;
use app\common\library\QqQrcodeLogin;
use app\common\library\Auth;
use think\facade\Config;
use think\facade\Db;
use think\facade\Filesystem;
use app\BaseController;
class Index extends BaseController
{
    public function initialize() {
        parent::initialize();
        $web = Config::get('website');
        if (!isset($web['status']))exitContent(view(config('app.maintain_tmpl'), ['webqq' => $web['webqq'],'webname' => $web['webname'],'cdn' => $web['cdn']]));

    }
    public function third() {
        $type = input('type');
        switch ($type) {
            // 获取QQ登录二维码
            case 'getQQLoginQrcode':
                // 获取二维码信息
                list($status, $info) = (new QqQrcodeLogin())->getQrcodeUrl();

                if ($status) {
                    session('qrobot_bind', $info['qrsig']);
                    return Json::success()->data($info)->res();
                }

                return Json::error($info)->res();
                break;
                // 获取QQ登录状态
            case 'getQQLoginStatus':
                // 查询sign
                $qrsig = (string)session('qrobot_bind');

                if (empty($qrsig)) {
                    return Json::error('请先获取二维码')->res();
                }

                list($status, $info) = (new QqQrcodeLogin())->queryStatus($qrsig);

                // 查询失败
                if (!$status) {
                    return Json::error($info)->res();
                }

                // 登录成功
                if ($info['code'] === 3) {
                    // QQ号
                    $qq = $info['msg'];
                    // 获取用户信息
                    $user = Db::table('user')->where(array('username' => session('username')))->find();

                    if (Db::table('user')->where(array('userqq' => $qq))->find()) {
                        $info['code'] = 4;
                        $info['msg'] = '该QQ已绑定';
                    }
                    if (!Db::table('user')->where(array('username' => session('username')))->update(['userqq' => $qq])) {
                        $info['code'] = 4;
                        $info['msg'] = '绑定失败';
                    }

                }

                if (in_array($info['code'], [3, -1])) {
                    session('qrobot_bind', null);
                }

                return Json::success()->data($info)->res();
                break;
        }
        return Json::error('不存在的操作类型')->res();
    }
    public function checkqq() {
        $type = input('qrcodetype');
        switch ($type) {
            // 获取QQ登录二维码
            case 'getQQLoginQrcode':
                // 获取二维码信息
                list($status, $info) = (new QqQrcodeLogin())->getQrcodeUrl();

                if ($status) {
                    session('qrobot_check', $info['qrsig']);
                    return Json::success()->data($info)->res();
                }

                return Json::error($info)->res();
                break;
                // 获取QQ登录状态
            case 'getQQLoginStatus':
                // 查询sign
                $qrsig = (string)session('qrobot_check');

                if (empty($qrsig)) {
                    return Json::error('请先获取二维码')->res();
                }

                list($status, $info) = (new QqQrcodeLogin())->queryStatus($qrsig);

                // 查询失败
                if (!$status) {
                    return Json::error($info)->res();
                }

                // 登录成功
                if ($info['code'] === 3) {
                    // QQ号
                    $qq = $info['msg'];
                    session('qq_check', $qq);

                }

                if (in_array($info['code'], [3, -1])) {
                    session('qrobot_check', null);
                }

                return Json::success()->data($info)->res();
                break;
        }
        return Json::error('不存在的操作类型')->res();
    }
    public function  captchaverifys() {
        $web = Config::get('website');
        $geetest_id = $web['geetest_id'];
        $geetest_key = $web['geetest_key'];
        $geetest = new GeetestLib($geetest_id,$geetest_key);
        $user_id = ip();
        $data = array(
            "user_id" => $user_id, # 网站用户id
            "client_type" => "web", #web:电脑上的浏览器；h5:手机上的浏览器，包括移动应用内完全内置的web_view；native：通过原生SDK植入APP应用的方式
            "ip_address" => ip(), # 请在此处传输用户请求验证时所携带的IP
        );
        $status = $geetest->pre_process($data,1);
        session('geetest_status', $status);
        session('geetest_user_id', $user_id);
        echo $geetest->get_response_str();
    }
    public function admin_login() {
       if (!session('adminuser')&&!session('adminqq')) {
            $this->error('请先登录管理员账户');
       }
        $username = input('post.username','','htmlspecialchars');
             //查找用户
            if ($username) $userdata = Db::table('user')->where(array('username' => $username))->find();

            if (!$userdata)$this->error('用户不存在');
            //是否封禁
            if ($userdata['userstate'] != 1)$this->error('该用户已被封禁');
            //储存session
            session('username',$username);

            session('userid',$userdata['id']);
            $this->success('你好，'.$username,'/user/index/index.html');
    }
    public function  buygrade() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录');
        }
        //输出系统信息
        $web = Config::get('website');

        //获取用户信息
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $id = input('post.id','','htmlspecialchars');
        $usergrade = Db::table('grade')->where(array('id' => $user['grade']))->find();
        $grade = Db::table('grade')->where(array('id' => $id))->find();
        if ($usergrade['weight'] >= $grade['weight']) {
            $this->error('不能升级比您现在低的等级');

        }
        if ($user['usermoney'] < $grade['money']) {
            $this->error('您还未满足要求');
        }
        $data['grade'] = $id;
        if (!Db::table('user')->where(array('username' => session('username')))->update($data)) {
            $this->error('升级失败，未知错误。');
        }
        $this->success('升级成功，请稍后...');
    }
    public function worder() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $this->assign('user',$user);
        $listdata = Db::table('worder');

        $this->assign('listdata',$listdata->where(array('user' => session('userid')))->paginate(15));
        //引入网站模板文件
        return view('user/'.$web['user_template'].'/html/worder');
    }
    public function worderinfo() {
        $id = input('get.id','','htmlspecialchars');
        //用户id
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        if (!$id) {
            $this->error('参数错误','/user/index/index.html',3);
        }
        $data = Db::table('worder')->where(array('id' => $id))->find();
        if (empty($data)) {
            $this->error('工单不存在','/user/index/index.html',3);
        }
        if ($data['user'] != session('userid')) {
            $this->error('这不是你的工单哦','/user/index/index.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $this->assign('user',$user);
        $rowdata = Db::table('worder');
        $this->assign('rowdata',$rowdata->where(array('id' => $id))->find());
        $data = Db::table('wreply');

        $this->assign('data',$data->where(array('worder' => $id))->order('time')->select());
        //输出模板文件
        return view('user/'.$web['user_template'].'/html/worderinfo');
    }
    //卡密兑换
    public function  kmdh() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        //获取用户信息
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $this->assign('user',$user);
        //输出模板文件
        return view('user/'.$web['user_template'].'/html/kmdh');
    }
    public function  worderinfos() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录');
        }
        $datas = Db::table('worder')->where(array('id' => input('id')))->find();
        if (empty($datas)) {
            $this->error('工单不存在');
        }
        if ($datas['user'] != session('userid')) {
            $this->error('这不是你的工单哦');
        }
        $data['person'] = session('username');
        $data['content'] = input('content');
        $data['worder'] = input('id');
        $data['time'] = date('Y-m-d H:i:s');
        Db::table('wreply')->insert($data);
        $datas['status'] = 0;
        Db::table('worder')->where(array('id' => input('id')))->update($datas);
        $this->success('回复成功');
    }
    public function  worderadds() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录');
        }
        $datas['title'] = input('title');
        $datas['user'] = session('userid');
        $datas['status'] = 0;
        Db::table('worder')->insert($datas);
        $newid = Db::table('worder')->max('id');

        $data['person'] = session('username');
        $data['content'] = input('content');
        $data['worder'] = $newid;
        $data['time'] = date('Y-m-d H:i:s');
        Db::table('wreply')->insert($data);
        $this->success('回复成功');
    }
    //卡密兑换
    public function  kmuse() {
        $km = input('post.km','','htmlspecialchars');
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录');
        }
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $kmdata = Db::table('kami')->where(array('km' => $km))->find();
        if (!$kmdata) {
            $this->error('未查询到此卡密');
        }
        if ($kmdata['state'] == 0) {
            $this->error('此卡密被使用过');
        }
        Db::table('kami')->where(array('km' => $km))->update(['state' => 0]);
        if ($kmdata['api'] == 0) {
            $data['usermoney'] = $user['usermoney']+$kmdata['money'];
            if (!Db::table('user')->where(array('username' => session('username')))->update($data)) {
                $this->error('兑换失败');
            }
            Pub::LingduMsg('卡密兑换提醒！','使用卡密：'.$km.'<br/>卡密内容：'.$kmdata['money'].'元<br/>现有余额：'.$data['usermoney'].'元<br/>欢迎您再次光顾本站！',session('username'));
            $this->success('兑换成功,兑换金额:'.$kmdata['money']);
        } else {
            $id = $kmdata['apiid'];
            $num = $kmdata['day']/30;
            //输出系统信息
            $web = Config::get('website');

            $apidata = Db::table('api')->where(array('id' => $id))->find();
            if (empty($apidata)) {
                $this->error('API不存在');
            }

            $userdata = Db::table('user')->where(array('username' => session('username')))->find();
            if (empty($userdata)) {
                $this->error('用户数据为空');
            }



            $ip = $apidata['apiip'];
            //api的ip
            //api的钱数
            $usetime = date('Y-m-d');
            //购买额日期
            $uselength = 30 * $num;
            //购买底数
            $apidatat = Db::table('apib')->where(array('apiip' => $apidata['apiip'],'username' => session('username')))->find();
            //获取用户是否购买过同类型

            $apiname = $apidata['apiname'];
            //api名称
            $apimoney = $apidata['apimoney'];
            //api钱数
            $apiusemoney = $apidata['apiusemoney'];
            //api调用钱数

            if (empty($apidatat)) {

                Db::table('apib')->insert(['username' => session('username'),'apiip' => $apidata['apiip'],'uselength' => $uselength,'usetime' => $usetime,'apiname' => $apiname,'apimoney' => $apimoney,'apiusemoney' => $apiusemoney]);
            } else {
                Db::table('apib')->where(array('username' => session('username'),'apiip' => $apidata['apiip']))->update(['uselength' => $apidatat['uselength'] + $uselength]);

            }
            $this->cron('1');
            Pub::LingduMsg('卡密兑换提醒！','使用卡密：'.$km.'<br/>卡密内容：'.$apidata['apiname'].'接口<br/>现有余额：'.$data['usermoney'].'<br/>欢迎您再次光顾本站！',session('username'));
            $this->success('兑换成功，兑换接口:'.$apidata['apiname']);
        }
    }
    //用户中心首页
    public function index() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        //获取用户信息
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        //判断是否有密钥
        if (empty($user['userkey'])) {
            $this->error('请先生成密匙','/user/index/accessSet.html',3);
        }
        $this->assign('user',$user);
        //输出公告
        $notice = Db::table('notice');
        $this->assign('notice',$notice->paginate(10));
        //统计数据
        $this->assign('userapi',Db::table('apib')->where(array('username' => session('username')))->count());
        $this->assign('userdown',Db::table('user')->where(array('upusername' => session('username')))->count());
        //输出模板文件
        return view('user/'.$web['user_template'].'/html/index');
    }
    //主机列表页面
    public function hostlist() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $this->assign('user',$user);
        foreach (Db::table('api')->select() as $k){
            $api[$k['apiip']]=$k['apiname'];
        }
        $this->assign('api',$api);
        $hostdata = Db::table('host');
        if (empty($_GET['keywords'])) {
            $this->assign('hostdata',$hostdata->where(array('username' => session('username')))->paginate(15));
        } else {
            $this->assign('hostdata',$hostdata->where(array('hostname' => $_GET['keywords'],'username' => session('username')))->paginate(15));
        }

        //引入网站模板文件
        return view('user/'.$web['user_template'].'/html/hostlist');
    }
    //主机添加页面
    public function hostadd() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $this->assign('user',$user);
        $this->assign('apidata',Db::table('apib')->where(array('username' => session('username')))->select());

        if ($this->request->isPost()) {
            $apidata = Db::table('apib')->where(array('username' => session('username'),'apiip' => input('apiip')))->find();
            $apidatas = Db::table('api')->where(array('apiip' => input('apiip')))->find();
            if (input('apiip') != $apidata['apiip']) {
                $this->error('这不是您的接口');
            }

            if ($apidata['apiusemoney'] > 0) {

                $userdata = Db::table('user')->where(array('username' => session('username')))->find();
                if (empty($userdata['grade'])) {
                    $gradeyh = 10/ 10;
                } else {
                    $usergrade = Db::table('grade')->where(array('id' => $userdata['grade']))->find();
                    $gradeyh = $usergrade['yh']/ 10;
                }
                $data['usermoney'] = $userdata['usermoney'] - ($apidata['apiusemoney']*$gradeyh);
                if ($data['usermoney'] < 0) {
                    $this->error('你的余额不足');
                }
              
            }
            if($apidatas['cert']=='1'&&$userdata['cert']=='0'){
                 $this->error('当前接口需要实名！');
            }
            $result = Host::createhost(input());
            if ($result['code'] == '0') {
                $this->error('开通失败,原因'.$result['msg']);
            }
              if ($apidata['apiusemoney'] > 0) {
              Db::table('user')->where(array('username' => session('username')))->update($data);
              }
            Db::table('apib')->where(array('apiip' => input('apiip'),'username' => session('username')))->update(['use' => $apidata['use'] + 1]);
            $apidataw = Db::table('api')->where(array('apiip' => input('apiip')))->find();
            Db::table('api')->where(array('apiip' => input('apiip')))->update(['apiuse' => $apidataw['apiuse'] + 1]);
            $this->success('开通成功');

        }
        //引入网站模板文件
        return view('user/'.$web['user_template'].'/html/hostadd');
    }
    //用户注册
    public function reg() {
        $logout = input('get.logout','','htmlspecialchars');
        //是否退出
        //判断是否登录
        if (session('username') && session('userid')) {
            $this->error('您已登录!','/user/index/index.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        if (!$web['isuserreg']) {
            $this->error('管理员未开启此功能','/',3);
        }
        $this->assign('web',$web);

        return view('login_reg/'.$web['login_reg_template'].'/html/reg');

    }


    //用户登录页面
    public function login() {
        $qqlogin = input('get.qqlogin','','htmlspecialchars');
        //是否使用qq登录
        $logout = input('get.logout','','htmlspecialchars');
        //是否退出
        if ($qqlogin) {
            //判断http协议头

            //登录成功返回地址
            $redirect = request()->domain() . url('user/index/logins');
            //发起qq登录
            $url = Pub::qqLogin($redirect);
            //跳转到qq登录页面

            return  redirect($url);
        }

        if ($logout) {

            //清除session
            session('username',null);

            session('userid',null);
            $this->success('退出成功','/user/index/login.html',3);
        }
        if (session('username') && session('userid')) {
            $this->error('您已登录!','/user/index/index.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        //引入网站模板文件
        return view('login_reg/'.$web['login_reg_template'].'/html/login');
    }
    public function findpass() {

        if (session('username') && session('userid')) {
            $this->error('您已登录!','/user/index/index.html',3);
        }
        if (input('do') && empty(input('username'))) {
            $this->error('信息不完整','/user/index/findpass.html',3);
        } elseif (input('do')&&!empty(input('username'))) {
            $user = Db::table('user')->where(array('username' => input('username')))->find();
            if (!$user)$this->error('用户名不存在','/user/index/findpass.html',3);
            $this->assign('user',$user);
            if (input('do') == '3' && empty(input('act')))$this->error('提交错误','/user/index/findpass.html',3);
            if (input('do') == '3' && input('act') == '2' && empty($user['useremail']))$this->error('提交错误','/user/index/findpass.html',3);
            if (input('do') == '3' && input('act') == '1' && empty($user['userphone']))$this->error('提交错误','/user/index/findpass.html',3);
            if (input('do') == '4'){
                $pass= input('post.pass','','htmlspecialchars');
                $yzm= input('post.yzm','','htmlspecialchars');
                if ($yzm != session('yzm')) {
                   $this->error('验证码错误');
                }
                Db::table('user')->where(array('username' => session('voucher')))->update(['userpwd' =>password_hash($pass, PASSWORD_DEFAULT)]);
                $this->success('修改成功');
            }
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        //引入网站模板文件
        return view('login_reg/'.$web['login_reg_template'].'/html/findpass');

    }
    public function  sendyzms() {
        $voucher = input('post.voucher','','htmlspecialchars');
        $act = input('post.act','','htmlspecialchars');
        $web = Config::get('website');
        if (!empty(session('yzmdate')) && time() - session('yzmdate') < 60) {
            $this->error('每60秒发送一次验证码');
        }
        $user = Db::table('user')->where(array('username' => $voucher))->find();
        if ($act == 'sms') {
            if (empty($user['userphone'])) {
                $this->error('提交错误');
            }
        } else {
            if (empty($user['useremail'])) {
                $this->error('提交错误');
            }
        }
        if ($act == 'sms' && $web['smstype'] == '978') {
            if (YZM::sendsms978($user['userphone'])['code']==0) {
                $this->error('发送失败，请重试。');
            }
        } elseif ($act == 'sms' && $web['smstype'] == 'bao') {
            if (YZM::sendsmsbao($user['userphone'])['code']==0) {
                $this->error('发送失败，请重试。');
            }
        } else {
            if (YZM::sendems($user['useremail'])['code']==0) {
                $this->error('发送失败，请重试。');
            }
        }
        session('yzmdate',time());
        session('voucher',$voucher);
        $this->success('发送成功,如果没收到验证码,请上垃圾箱查看！');
    }
    //验证码发送
    public function   sendyzm() {
        $voucher = input('post.voucher','','htmlspecialchars');
        $web = Config::get('website');
        if ($web['verification'] == 'no') {
            $this->error('管理员未开启此功能');
        }

        if (!empty(session('yzmdate')) && time() - session('yzmdate') < 60) {
            $this->error('每60秒发送一次验证码');
        }
        if ($web['verification'] == 'sms') {
            if (!empty(Db::table('user')->where(array('userphone' => $voucher))->find())) {
                $this->error('手机号已注册');
            }
        } else {
            if (!empty(Db::table('user')->where(array('useremail' => $voucher))->find())) {
                $this->error('邮箱已注册');
            }
            if (!Pub::check_mail($voucher)) {
                $this->error('邮箱不正确');
            }
        }
        if ($web['verification'] == 'sms' && $web['smstype'] == '978') {
            if (YZM::sendsms978($voucher)['code']==0) {
                $this->error('发送失败，请重试。');
            }
        } elseif ($web['verification'] == 'sms' && $web['smstype'] == 'bao') {
            if (YZM::sendsmsbao($voucher)['code']==0) {
                $this->error('发送失败，请重试。');
            }
        } else {
            if (YZM::sendems($voucher)['code']==0) {
                $this->error('发送失败，请重试。');
            }
        }
        session('yzmdate',time());
        session('regvoucher',$voucher);
        $this->success('发送成功,如果没收到邮件,请上垃圾箱查看！');
    }


    //用户注册功能
    public function regs() {
        $username = input('post.username','','htmlspecialchars');
        $userpwd = password_hash(input('post.userpwd','','htmlspecialchars'), PASSWORD_DEFAULT);
        $voucher = input('post.voucher','','htmlspecialchars');
        $yzm = input('post.yzm','','htmlspecialchars');
        $upuserid = input('post.upuserid','','htmlspecialchars');
        if (session('username') && session('userid')) {
            $this->error('您已登录!','/user/index/index.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        if (!$web['isuserreg']) {
            $this->error('管理员未开启此功能');
        }
        if ($web['userverify'] == 'vaptcha') {
            $url = 'http://0.vaptcha.com/verify';
            $_data['id'] = $web['vaptcha_id'];
            $_data['secretkey'] = $web['vaptcha_key'];
            $_data['scene'] = 0;
            $_data['token'] = input('post.token','','htmlspecialchars');
            $_data['ip'] = ip();
            $result = Pub::request_post($url,$_data);
            $result = json_decode($result, TRUE);
            if ($result['success'] != 1) {
                $this->error($result['msg']);
            }
        } elseif ($web['userverify'] == 'captcha') {
            $geetest_id = $web['geetest_id'];
            $geetest_key = $web['geetest_key'];

            if (!Pub::geetest_chcek_verify($geetest_id,$geetest_key,input('post.geetest_challenge','','htmlspecialchars'), input('post.geetest_validate','','htmlspecialchars'), input('post.geetest_seccode','','htmlspecialchars'))) {
                $this->error('图形验证失败');
            }
        }
        if ((empty($yzm) || empty($voucher)) && ($web['verification'] == 'sms' || $web['verification'] == 'ems')) {
            $this->error('信息不完整');
        }
        $userdatas = Db::table('user')->where(array('username' => $username))->find();
        if ($voucher != session('regvoucher') && $web['verification'] == 'sms') {
            $this->error('手机号不匹配');
        }
        if (!empty($userdatas)) {
            $this->error('用户已存在');
        }
        if (!empty($upuserid) && empty(Db::table('user')->where(array('id' => $upuserid))->find())) {

            $this->error('上级用户不存在');
        }
        if ($yzm != session('yzm') && ($web['verification'] == 'sms' || $web['verification'] == 'ems')) {
            $this->error('验证码错误');
        }
        if ($voucher != session('qq_check') && ($web['verification'] != 'sms' && $web['verification'] != 'ems')) {
            $this->error('扫描QQ与填写QQ不符');
        }
        if (($web['verification'] != 'sms' && $web['verification'] != 'ems') && Db::table('user')->where(array('userqq' => $voucher))->find()) {
            $this->error('QQ已经被注册');

        }
        $data['username'] = $username;
        $data['userpwd'] = $userpwd;
        if ($web['verification'] == 'sms') {
            $data['userphone'] = $voucher;
        } elseif ($web['verification'] == 'ems') {
            $data['useremail'] = $voucher;
        } else {
            $data['userqq'] = $voucher;
        }

        if (isset($upuserid)) {
            $upuserdata = Db::table('user')->where(array('id' => $upuserid))->find();
            $upusername = $upuserdata['username'];
            $data['upusername'] = $upusername;
        }

        if (!Db::table('user')->insert($data)) {
            $this->error('注册失败，未知错误。');
        }
        if (!empty($upuserid)) {
            $userdata = Db::table('user')->where(array('username' => $username))->find();
            $data2['downuserid'] = $userdata['id'];
            $data2['upuserid'] = $upuserid;
            Db::table('userb')->insert($data2);
        }
        if ($web['verification'] == 'sms' || $web['verification'] == 'ems') {
            session('regvoucher',null);
            session('yzm',null);
        }
        Db::table('user')->where(array('username' => $username))->update(['usermoney' => $web['regmoney']]);

        if (isset($upuserid)) {
            $upuserdata = Db::table('user')->where(array('id' => $upuserid))->find();

            Db::table('user')->where(array('id' => $upuserid))->update(['usermoney' => $upuserdata['usermoney']+$web['regmoney']]);
        }
        $this->success('注册成功，请稍后...');
    }
    public function logins() {
        //获取填写信息
        $username = input('post.username','','htmlspecialchars');
        //用户名
        $userpwd = input('post.userpwd','','htmlspecialchars');
        //用户密码
        $code = input('get.code','','htmlspecialchars');
        //登录code
        $state = input('get.state','','htmlspecialchars');
        $qrcodetype = input('qrcodetype');
        //登录
        if (!empty($qrcodetype)) {
            switch ($qrcodetype) {
                // 获取QQ登录二维码
                case 'getQQLoginQrcode':
                    // 获取二维码信息
                    list($status, $info) = (new QqQrcodeLogin())->getQrcodeUrl();

                    if ($status) {
                        session('qrobot_login', $info['qrsig']);
                        return Json::success()->data($info)->res();
                    }

                    return Json::error($info)->res();
                    break;
                    // 获取QQ登录状态
                case 'getQQLoginStatus':
                    // 查询sign
                    $qrsig = (string)session('qrobot_login');

                    if (empty($qrsig)) {
                        return Json::error('请先获取二维码')->res();
                    }

                    list($status, $info) = (new QqQrcodeLogin())->queryStatus($qrsig);

                    // 查询失败
                    if (!$status) {
                        return Json::error($info)->res();
                    }

                    // 登录完成
                    if ($info['code'] === 3) {
                        // QQ号
                        $qq = $info['msg'];
                        // 获取用户信息
                        $user = Db::table('user')->where(array('userqq' => $qq))->find();
                        if (empty($user)) {
                            $info['code'] = 4;
                            $info['msg'] = '该QQ未绑定';
                        }
                        //存储session
                        session('username',$user['username']);

                        session('userid',$user['id']);
                        //记录ip
                        $ip = ip();
                        $loginuser['userip'] = $ip;
                        //存储到数据库
                        Db::table('user')->where(array('username' => $user['username']))->update($loginuser);

                    }

                    if (in_array($info['code'], [3, -1])) {
                        session('qrobot_login', null);
                    }

                    return Json::success()->data($info)->res();
                    break;
            }
        } elseif (!empty($code)) {
            //判断登录
            if (session('username') && session('userid')) {
                $this->error('您已登录!','/user/index/index.html',3);
            }
            //判断状态码
            if ($state != session('state')) {
                $this->error('状态码错误!','/user/index/login.html',3);
            }
            //查找用户
            $data = Db::table('user')->where(array('qqopenid' => $code))->find();
            //判断是否绑定
            if (empty($data)) {
                $this->error('该QQ未绑定','/user/index/login.html',3);
            }
            //存储session
            session('username',$data['username']);

            session('userid',$data['id']);
            //记录ip
            $ip = ip();
            $loginuser['userip'] = $ip;
            //存储到数据库
            Db::table('user')->where(array('username' => $data['username']))->update($loginuser);
            $this->success('登录成功!','/user/index/index.html',3);
        } else {
            $web = Config::get('website');
            if ($web['userverify'] == 'vaptcha') {
                $url = 'http://0.vaptcha.com/verify';
                $_data['id'] = $web['vaptcha_id'];
                $_data['secretkey'] = $web['vaptcha_key'];
                $_data['scene'] = 0;
                $_data['token'] = input('post.token','','htmlspecialchars');
                $_data['ip'] = ip();
                $result = Pub::request_post($url,$_data);
                $result = json_decode($result, TRUE);
                if ($result['success'] != 1) {
                    $this->error($result['msg']);
                }
            } elseif ($web['userverify'] == 'captcha') {
                $geetest_id = $web['geetest_id'];
                $geetest_key = $web['geetest_key'];
                if (!Pub::geetest_chcek_verify($geetest_id,$geetest_key,input('post.geetest_challenge','','htmlspecialchars'), input('post.geetest_validate','','htmlspecialchars'), input('post.geetest_seccode','','htmlspecialchars'))) {
                    $this->error('图形验证失败');
                }
            }


            //查找用户
            if ($username) $userdata = Db::table('user')->where(array('username' => $username))->find();

            if (!$userdata)$this->error('用户不存在');
            //判断密码
            if (!password_verify($userpwd,$userdata['userpwd']))$this->error('密码错误');
            //是否封禁
            if ($userdata['userstate'] != 1)$this->error('您已被封禁');
            //储存session
            session('username',$username);

            session('userid',$userdata['id']);
            //记录ip
            $ip = ip();
            $loginuser['userip'] = $ip;
            //存储到数据库
            Db::table('user')->where(array('username' => $username))->update($loginuser);
            $this->success('你好，'.$username);
        }
    }


    public function upd() {
        if (!session('username')&&!session('userid')) {
            $this->error('未登录');
        }
        $file = request()->file('file');
        //验证文件规则
        $result = validate(['file' => ['fileSize'=>102400,'fileExt'=>'gif,jpg,png']])->check(['file' => $file]);
        if ($result) {
            //上传到服务器,
            $path = Filesystem::disk('public')->putFile('upload',$file);

            $picCover = Filesystem::getDiskConfig('public','url').'/'.str_replace('\\','/',$path);

            //获取图片名称
            $fileName = $file->getOriginalName();
            $jsondata = ['status' => '1','info' => '上传成功','location' => request()->domain().$picCover];

        } else {
            $jsondata = ['status' => '0','info' => '文件不符合要求','location' => '文件不符合要求'];
        }
        exit(json_encode($jsondata));
    }
    public function  bindqrobot() {
        if (!session('username')&&!session('userid')) {
            $this->error('未登录','/user/index/index.html',3);
        }
        if (!Db::table('user')->where(array('username' => session('username')))->update(['userqq' => ''])) {
            $this->error('解绑失败','/user/index/index.html',3);
        }
        $this->success('解绑成功','/user/index/index.html',3);
    }
    //绑定QQ or 重新绑定
    public function  bindqq() {
        if (!session('username')&&!session('userid')) {
            $this->error('未登录','/user/index/index.html',3);
        }
        $code = input('get.code','','htmlspecialchars');
        //qq登录code
        $state = input('get.state','','htmlspecialchars');
        //qq登录state
        if ($code) {
            if ($state != session('state')) {
                $this->error('Key验证失败','/user/index/index.html',3);
            }
            //查找用户信息
            $data = Db::table('user')->where(array('qqopenid' => $code))->find();
            //判断是否绑定
            if (!empty($data)) {
                $this->error('该QQ已被绑定','/user/index/index.html',3);
            }

            if (!Db::table('user')->where(array('username' => session('username')))->update(['qqopenid' => $code])) {
                $this->error('绑定失败','/user/index/index.html',3);
            }
            session('state',null);
            $this->success('绑定成功','/user/index/index.html',3);
        }

        //登录成功返回地址
        $redirect = request()->domain() . url('user/index/bindqq');
        //发起qq登录
        $url = Pub::qqLogin($redirect);
        //跳转到qq登录页面
        return  redirect($url);
    }



    //修改密码
    public function  editpwd() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        //获取用户信息
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $this->assign('user',$user);
        //输出模板文件
        return view('user/'.$web['user_template'].'/html/editpwd');
    }

    public function  worderadd() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        //获取用户信息
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $this->assign('user',$user);
        //输出模板文件
        return view('user/'.$web['user_template'].'/html/worderadd');
    }



    //修改密码功能
    public function  editpwds() {
        $userpwd = input('post.userpwd','','htmlspecialchars');
        //原密码
        $newuserpwd = input('post.newuserpwd','','htmlspecialchars');
        //新密码
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录');
        }
        //获取用户信息
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        if (!password_verify($userpwd,$user['userpwd'])) {
            $this->error('原密码错误');
        }
        //保存到数据库
        $xgmm['userpwd'] = password_hash($newuserpwd, PASSWORD_DEFAULT);
        if (!Db::table('user')->where(array('username' => session('username')))->update($xgmm)) {
            $this->error('修改失败，未知错误。');
        }
        //清除session
        session('username',null);

        session('userid',null);
        $this->success('修改成功，请稍后...');
    }



    //接口购买
    public function  apibuy() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        if (!$web['userbuyapi']) {
            $this->error('管理员未开启此功能','/user/index/index.html',3);
        }
        //获取用户信息
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $this->assign('user',$user);
        $this->assign('says',Pub::random_str());
        $apidata = Db::table('api');
        if (empty($user['grade'])) {
            $gradeyh = '10';
        } else {
            $usergrade = Db::table('grade')->where(array('id' => $user['grade']))->find();
            $gradeyh = $usergrade['yh'];
        }
        $this->assign('gradeyh',$gradeyh);
        $this->assign('apiclassdata',Db::table('apiclass')->where(array('isshow' => 1))->select());
        if (empty(input('class'))) {
            $this->assign('apidata',$apidata->where(array('isshow' => 1))->select());
        } else {
            $this->assign('apidata',$apidata->where(array('isshow' => 1,'apiclass' => input('class')))->select());
        }
        //输出模板文件
        return view('user/'.$web['user_template'].'/html/apibuy');
    }
    public function  allbuys() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        if (!$web['userbuyapi']) {
            $this->error('管理员未开启此功能','/user/index/index.html',3);
        }
        //获取用户信息
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $this->assign('user',$user);
        $apidata = Db::table('api');
        if (empty($user['grade'])) {
            $gradeyh = '10';
        } else {
            $usergrade = Db::table('grade')->where(array('id' => $user['grade']))->find();
            $gradeyh = $usergrade['yh'];
        }
        $this->assign('gradeyh',$gradeyh);
        $this->assign('apidata',$apidata->where(array('isshow' => 1))->select());
        //输出模板文件
        return view('user/'.$web['user_template'].'/html/allbuys');
    }
    //接口列表
    public function  apilist() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        //获取用户信息
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $this->assign('user',$user);
        $apidata = Db::table('apib');
        $this->assign('apidata',$apidata->where(array('username' => session('username')))->paginate(15));
        //输出模板文件
        return view('user/'.$web['user_template'].'/html/apilist');
    }
    public function  price() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        //获取用户信息
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $this->assign('user',$user);
        $data = Db::table('grade');
        if (empty($user['grade'])) {
            $grade = '默认等级';
        } else {
            $usergrade = Db::table('grade')->where(array('id' => $user['grade']))->find();
            $grade = $usergrade['name'];
        }
        $this->assign('grade',$grade);
        $this->assign('data',$data->paginate(15));
        //输出模板文件
        return view('user/'.$web['user_template'].'/html/price');
    }


    //对接教程
    public function   accesscourse() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        //获取用户信息
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $this->assign('user',$user);
        //输出模板文件
        return view('user/'.$web['user_template'].'/html/accesscourse');
    }


    //在线充值页面
    public function    pay() {
        $pay_id = input('get.pay_id','','htmlspecialchars');
        $out_trade_no = input('get.out_trade_no','','htmlspecialchars');
        $money = input('post.money','','htmlspecialchars');
        $type = input('post.type','','htmlspecialchars');
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        if (!$web['userpaymoney']) {
            $this->error('管理员未开启此功能','/user/index/index.html',3);
        }
        if (!empty($pay_id)) {
            codePay::returnp($_GET, $pay_id);
        }
        if (!empty($out_trade_no)) {
            ePay::returnp($out_trade_no);
        }
        if (!empty($money)) {
            $url = ($_SERVER['SERVER_PORT'] == '443' ? 'https://' : 'http://') . $_SERVER['HTTP_HOST']. '/user/index/pay.html';
            if ($web['alipay'] == 'f2f' && $type == 'alipay') {
                $out_trade_no = date('YmdHis').mt_rand(000,999);
                $pay['out_trade_no'] = $out_trade_no;
                $pay['money'] = $money;
                $pay['username'] = session('username');
                $pay['date'] = date('Y-m-d');
                if (!Db::table('pay')->insert($pay)) {
                    $this->error('创建订单失败', '/user');
                }
                $pay = new F2fpay($this->app);
                return $pay->topay($out_trade_no, $money);
            }
            if (($web['alipay'] == 'epay' && $type == 'alipay') || ($web['qqpay'] == 'epay' && $type == 'qqpay') || ($web['wxpay'] == 'epay' && $type == 'wxpay')) {
                $epayurl = $web['epaylink'].'api.php?act=query&pid='.$web['epaypid'].'&key='.$web['epaykey'];
                 $epaydata = json_decode(Pub::curl_request($epayurl),true);
                if ($epaydata['code'] != 1) {
                    $this->error('易支付配置有误，请联系管理员','/user/index/index.html',3);
                }
                new ePay(
                    $web['epaylink'],
                    $web['epaypid'],
                    $web['epaykey'],
                    $web['webname'] . '在线充值',
                    $web['webname'],
                    $money,
                    $type,
                    $url,
                    $url
                );
            }
            if (($web['alipay'] == 'codepay' && $type == 'alipay') || ($web['qqpay'] == 'codepay' && $type == 'qqpay') || ($web['wxpay'] == 'codepay' && $type == 'wxpay')) {
                if (empty($web['codepayid']) || empty($web['codepaykey']))if ($epaydata['code'] != 1) {
                    $this->error('码支付配置有误，请联系管理员','/user/index/index.html',3);
                }
                new codePay(
                    $web['codepayid'],
                    $web['codepaykey'],
                    $type,
                    $money,
                    $url
                );
            }
        }
        $this->assign('web',$web);
        //获取用户信息
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $this->assign('user',$user);
        //输出模板文件
        return view('user/'.$web['user_template'].'/html/pay');
    }
    //对接配置页面
    public function    accessset() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        //输出系统信息
        $web = Config::get('website');
        $this->assign('web',$web);
        //获取用户信息
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $this->assign('user',$user);
        //输出模板文件
        return view('user/'.$web['user_template'].'/html/accessset');
    }


    //对接配置功能
    public function    makekey() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录!','/user/index/login.html',3);
        }
        $key['safeip'] = input('post.safeip','','htmlspecialchars');
        $key['userkey'] = Pub::GetRandStrrand(48);
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        if (!Db::table('user')->where(array('username' => session('username')))->update($key)) {
            $this->error('操作失败，未知错误。');
        }

        $this->success('操作成功');
    }


    //接口删除
    public function  deluserapi() {
        $id = input('post.id','','htmlspecialchars');
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录');
        }
        $apidata = Db::table('apib')->where(array('id' => $id))->find();
        if (empty($apidata)) {
            $this->error('API不存在');
        }
        if ($apidata['username'] != session('username')) {
            $this->error('该接口不属于你');
        }
        //保存到数据库
        if (!Db::table('apib')->where(array('id' => $id))->delete()) {
            $this->error('删除失败，未知错误。');
        }
        $this->success('删除成功，请稍后...');
    }


    //接口监控
    public function  cron($type = '0') {
        $data = Db::table('apib')->where(array('isshow' => 1))->select();
        foreach ($data as $item) {
            $goodday = $item['uselength']*24*60*60;
            $cd = round(((strtotime($item['usetime'])+$goodday)-time())/24/3600,2);
            $item_id = $item['id'];
            if ($cd <= 0) {
                Pub::LingduMsg('接口删除提醒！','接口IP：'.$item['apiip'].'<br/>删除原因：接口到期自动删除<br/>请您下次及时续费确保接口的正常！',$item['username']);
                Db::table('apib')->where(array('id' => $item_id))->delete();
            }
            $cron['uselengthcd'] = $cd;
            $result = Db::table('apib')->where(array('id' => $item_id))->update($cron);
            if ($type == '0')echo "执行成功 ID:".$item_id."</br>";

        }
    }
    public function  crons() {
        $data = Db::table('apib')->where(array('isshow' => 1))->select();
        foreach ($data as $item) {
            $goodday = $item['uselength']*24*60*60;
            $cd = round(((strtotime($item['usetime'])+$goodday)-time())/24/3600,2);
            $item_id = $item['id'];
            if ($cd <= $web['dqday']) {
                Pub::LingduMsg('接口即将到期提醒！','接口IP：'.$item['apiip'].'<br/>剩余天数：'.$cd.'<br/>下次续费金额：'.$item['apimoney'].'/月<br/>请您及时续费确保接口的正常！',$item['username']);
            }
            echo "执行成功 ID:".$item_id."</br>";

        }
    }
    public function  apicron() {
        $data = Db::table('api')->where(array('isshow' => 1))->select();
        foreach ($data as $apidata) {
       if ($apidata['self'] == 0) {
            $url = $apidata['apiurl'].'Index/checkapi.html';
            $postdata = array(
                'username' => $apidata['apiusername'],
                'userkey' => (new Auth)->decrypt($apidata['apikey']),
                'apiip' => $apidata['apiip']
            );
            $resultdata = Pub::request_post($url, $postdata);
            $resultdata = json_decode($resultdata, TRUE);
            if ($resultdata['status'] != 1)$apistate = true;
        } else {
            if ($apidata['type'] == 'bt') {
                $auth_cofig = Config::get('auth');
                $auth_dekey = $auth->decode(session('authcode'. md5($auth_cofig['auth_id'])));
                    if (substr($auth_dekey, -7) != '1_lhost') {
                $apistate = false;
               }
                $panel = new Btpanel($apidata['apiurl'], (new Auth)->decrypt($apidata['apikey']));
                if ($apidata['os'] == 'linux') {
                    $apistate = $panel->get_server_status('linux');
                } else {
                    $apistate = $panel->get_server_status('win');
                }
            } else {
                $panel = new Epanel($apidata['apiurl'], (new Auth)->decrypt($apidata['apikey']));
                $apistate = $panel ->test();
            }
        }
            //更新接口
            if ($apistate) {

                $api['apistate'] = 1;
                if ($apidata['apistate'] != $api['apistate']) {
                    Pub::LingduMsgs('接口状态变更提醒！','接口IP：'.$apidata['apiip'].'<br/>本接口通过监控已经将接口状态转为正常<br/>请您及时查看网站后台！');
                }
                $edit = Db::table('api')->where(array('id' => $apidata['id']))->update($api);
                echo $edit."</br>";
            } else {
                $api['apistate'] = 2;
                if ($apidata['apistate'] != $api['apistate']) {
                    Pub::LingduMsgs('接口状态变更提醒！','接口IP：'.$apidata['apiip'].'<br/>本接口通过监控已经将接口状态转为无效<br/>请您及时查看网站后台！');
                }
                $edit = Db::table('api')->where(array('id' => $apidata['id']))->update($api);
                echo $edit."</br>";
            }

        }

    }

    //接口购买
    public function  buys() {
        $id = input('post.id','','htmlspecialchars');
        $num = input('post.num','','htmlspecialchars');
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录');
        }
        //输出系统信息
        $web = Config::get('website');
        if (!$web['userbuyapi']) {
            $this->error('管理员未开启此功能');
        }
        $apidata = Db::table('api')->where(array('id' => $id))->find();
        if (empty($apidata)) {
            $this->error('API不存在');
        }

        $userdata = Db::table('user')->where(array('username' => session('username')))->find();
        if (empty($userdata)) {
            $this->error('用户数据为空');
        }
        if (empty($userdata['grade'])) {
            $gradeyh = 10/ 10;
        } else {
            $usergrade = Db::table('grade')->where(array('id' => $userdata['grade']))->find();
            $gradeyh = $usergrade['yh']/ 10;
        }
        $needapimoney = $apidata['apimoney']*$gradeyh;
        if ($userdata['usermoney'] < $needapimoney * $num) {
            $this->error('余额不足');
        }


        $ip = $apidata['apiip'];
        //api的ip
        $money = $needapimoney * $num;
        //api的钱数
        $usetime = date('Y-m-d');
        //购买额日期
        $uselength = 30 * $num;
        //购买底数
        $apidatat = Db::table('apib')->where(array('apiip' => $apidata['apiip'],'username' => session('username')))->find();
        //获取用户是否购买过同类型

        $apiname = $apidata['apiname'];
        //api名称
        $apimoney = $apidata['apimoney'];
        //api钱数
        $apiusemoney = $apidata['apiusemoney'];
        //api调用钱数
        if ($money > 0) {
            //判断金额是否大于0

            Db::table('user')->where(array('username' => session('username')))->update(['usermoney' => $userdata['usermoney'] - $money]);
            if ($money >= 1) {
                //判断是否大于一好来提成
                $upticheng = $web['upticheng'] / 100;
                //提成比例
                $ticheng = $money * $upticheng;
                //提成金额


                $updata = Db::table('userb')->where(array('downuserid' => $userdata['id']))->find();
                if (!empty($updata)) {
                    //如果上级不为空
                    $upuserid = $updata['upuserid'];
                    $upuserdata = Db::table('user')->where(array('id' => $upuserid))->find();
                    Db::table('user')->where(array('id' => $upuserid))->update(['usermoney' => $upuserdata['usermoney'] + $ticheng]);
                    $updatas = Db::table('userb')->where(array('downuserid' => $updata['upuserid']))->find();
                    if (!empty($updatas)) {
                        //如果上级上级不为空

                        $upuserids = $updatas['upuserid'];
                        //上级上级id
                        $upuserdatas = Db::table('user')->where(array('id' => $upuserids))->find();
                        Db::table('user')->where(array('id' => $upuserid1))->update(['usermoney' => $upuserdatas['usermoney'] + $ticheng]);
                    }
                }
            }

        }

        if (empty($apidatat)) {

            Db::table('apib')->insert(['username' => session('username'),'apiip' => $apidata['apiip'],'uselength' => $uselength,'usetime' => $usetime,'apiname' => $apiname,'apimoney' => $apimoney,'apiusemoney' => $apiusemoney,'type' => $apidata['type']]);
        } else {
            Db::table('apib')->where(array('username' => session('username'),'apiip' => $apidata['apiip']))->update(['uselength' => $apidatat['uselength'] + $uselength]);

        }
        $this->cron('1');
        Pub::LingduMsg('购买成功提醒！','接口IP：'.$ip.'<br/>接口余额：'.$apidata['apimoney'].'/月<br/>购买时长：'.$num.'月<br/>消费余额：'.$money.'<br/>欢迎您的下次购买！',session('username'));
        $this->success('购买成功，请稍后...');
    }
    public function  allbuyss() {
        //判断是否登录
        if (!session('username')&&!session('userid')) {
            $this->error('请先登录');
        }
        $web = Config::get('website');
        if (!$web['userbuyapi']) {
            $this->error('管理员未开启此功能');
        }
        $nrs = input('post.nrs','','htmlspecialchars');
        $nrs = json_decode($nrs, true);
        $return = '';
        foreach ($nrs as $value) {
            $id = $value;
            $num = input('post.num','','htmlspecialchars');
            $apidata = Db::table('api')->where(array('id' => $id))->find();
            if (empty($apidata)) {
                $return .= $value.'接口返回信息:API不存在</br>';
                continue;
            }

            $userdata = Db::table('user')->where(array('username' => session('username')))->find();
            if (empty($userdata)) {
                $return .= $value.'接口返回信息:用户数据为空</br>';
                continue;
            }
            if (empty($userdata['grade'])) {
                $gradeyh = 10/ 10;
            } else {
                $usergrade = Db::table('grade')->where(array('id' => $userdata['grade']))->find();
                $gradeyh = $usergrade['yh']/ 10;
            }
            $needapimoney = $apidata['apimoney']*$gradeyh;
            if ($userdata['usermoney'] < $needapimoney * $num) {
                $return .= $value.'接口返回信息:余额不足</br>';
                continue;
            }


            $ip = $apidata['apiip'];
            //api的ip
            $money = $needapimoney * $num;
            //api的钱数
            $usetime = date('Y-m-d');
            //购买额日期
            $uselength = 30 * $num;
            //购买底数
            $apidatat = Db::table('apib')->where(array('apiip' => $apidata['apiip'],'username' => session('username')))->find();
            //获取用户是否购买过同类型

            $apiname = $apidata['apiname'];
            //api名称
            $apimoney = $apidata['apimoney'];
            //api钱数
            $apiusemoney = $apidata['apiusemoney'];

            //api调用钱数
            if ($money > 0) {
                //判断金额是否大于0

                Db::table('user')->where(array('username' => session('username')))->update(['usermoney' => $userdata['usermoney'] - $money]);
                if ($money >= 1) {
                    //判断是否大于一好来提成
                    $upticheng = $web['upticheng'] / 100;
                    //提成比例
                    $ticheng = $money * $upticheng;
                    //提成金额


                    $updata = Db::table('userb')->where(array('downuserid' => $userdata['id']))->find();
                    if (!empty($updata)) {
                        //如果上级不为空
                        $upuserid = $updata['upuserid'];
                        $upuserdata = Db::table('user')->where(array('id' => $upuserid))->find();
                        Db::table('user')->where(array('id' => $upuserid))->update(['usermoney' => $upuserdata['usermoney'] + $ticheng]);
                        $updatas = Db::table('userb')->where(array('downuserid' => $updata['upuserid']))->find();
                        if (!empty($updatas)) {
                            //如果上级上级不为空

                            $upuserids = $updatas['upuserid'];
                            //上级上级id
                            $upuserdatas = Db::table('user')->where(array('id' => $upuserids))->find();
                            Db::table('user')->where(array('id' => $upuserid1))->update(['usermoney' => $upuserdatas['usermoney'] + $ticheng]);
                        }
                    }
                }

            }

            if (empty($apidatat)) {

                Db::table('apib')->insert(['username' => session('username'),'apiip' => $apidata['apiip'],'uselength' => $uselength,'usetime' => $usetime,'apiname' => $apiname,'apimoney' => $apimoney,'apiusemoney' => $apiusemoney,'type' => $apidata['type']]);
            } else {
                Db::table('apib')->where(array('username' => session('username'),'apiip' => $apidata['apiip']))->update(['uselength' => $apidatat['uselength'] + $uselength]);

            }
            Pub::LingduMsg('购买成功提醒！','接口IP：'.$ip.'<br/>接口余额：'.$apidata['apimoney'].'/月<br/>购买时长：'.$num.'月<br/>消费余额：'.$money.'<br/>欢迎您的下次购买！',session('username'));
            $return .= $value.'号接口返回信息:购买成功</br>';
        }
        $this->cron('1');
        $this->success($return);
    }
}