<?php

namespace app\user\library;
use app\user\library\Tips;
use think\facade\Db;
use app\common\library\Pub;
class codePay
{
    public function __construct($id, $key, $type, $money, $return_url, $notify_url = NULL) {
        if ($type == 'alipay')$type = 1;
        if ($type == 'qqpay')$type = 2;
        if ($type == 'wxpay')$type = 3;

        $pay_id = date('YmdHis').mt_rand(100,999);
        $ary = array(
            'id' => $id,
            'pay_id' => $pay_id,
            'type' => $type,
            'price' => $money,
            'return_url' => $return_url,
            'notify_url' => $notify_url
        );

        $pay['out_trade_no'] = $pay_id;
        $pay['money'] = $money;
        $pay['username'] = session('username');
        $pay['date'] = date('Y-m-d');
        if (!Db::table('pay')->insert($pay)) {
            Tips::error('创建订单失败', '/user');
        }
        $this->submit($ary, $id, $key);
    }
    public function submit($ary, $id, $key) {
        $apilink = 'http://codepay.kjkl8.com/creat_order/?';
        $arylink = $this->arylink($this->arysort($ary));
        $signlink = $this->signlink($this->arysort($ary));
        $md5sign = $this->md5sign($signlink, $key);
        $querylink = $apilink . $arylink . '&sign=' . $md5sign;
        exit(str_replace('https://codepay.yy2169.com','https://codepay.kjkl8.com',str_replace('https://codepay.fateqq.com','https://codepay.kjkl8.com',Pub::curl_request($querylink))));
        //exit('<script>location.href = "' . $querylink . '"</script>');
    }
    public static function returnp($data, $out_trade_no) {
        $paydata = Db::table('pay')->where(array('out_trade_no' => $out_trade_no))->find();

        if (empty($paydata)) {
            Tips::error('订单不存在，有疑问请联系管理员。', '/user');
        }
        if ($paydata['state'] == 1) {
            Tips::error('订单已成功充值，有疑问请联系管理员。', '/user');
        }
        if ($paydata['money'] != $data['money']) {
            Tips::error('充值金额有误，有疑问请联系管理员。', '/user');
        }
        $user = Db::table('user')->where(array('username' => session('username')))->find();
        $paydata['money'] = $paydata['money'] + $paydata['money'] * (Config::get('website')['payfree'] / 100);
        if (!Db::table('user')->where(array('username' => session('username')))->update(['usermoney'=>$user['usermoney'] + $paydata['money']])) {
            Tips::error('充值失败，有疑问请联系管理员。', '/user');
        }
        if (!Db::table('pay')->where(array('out_trade_no' => $paydata['out_trade_no']))->update(['state' => 1])) {
            Tips::error('修改状态失败，有疑问请联系管理员。', '/user');
        }
         Pub::LingduMsg('充值成功提醒！','充值金额：'.$paydata['money'].'<br/>现有余额：'.$user['usermoney'] + $paydata['money'].'<br/>充值用户：'.session('username').'<br/>欢迎您下次充值！',session('username'));
         Pub::LingduMsgs('用户充值提醒！','用户充值金额：'.$paydata['money'].'<br/>用户目前余额：'.$user['usermoney'] + $paydata['money'].'<br/>充值用户：'.session('username'));
        Tips::success('充值成功，请稍后。', '/user');
    }
    public function arylink($ary) {
        $url = '';

        foreach ($ary as $key => $val) {
            if ($val == '' || $key == 'sign') continue;

            $url .= "$key=" . urlencode($val) . '&';
        }

        return trim($url, '&');
    }
    public function signlink($ary) {
        $sign = '';

        foreach ($ary as $key => $val) {
            if ($val == '' || $key == 'sign') continue;

            $sign .= "{$key}={$val}&";
        }

        return trim($sign, '&');
    }
    public function arysort($ary) {
        ksort($ary);
        reset($ary);
        return $ary;
    }
    public function md5sign($signlink, $key) {
        return md5($signlink .$key);
    }
}