<?php

namespace app\user\library;
use think\facade\Db;
use think\facade\Config;
use app\user\library\Tips;
use app\common\library\Pub;
class ePay
{
   
    public function __construct($epaylink, $epaypid, $epaykey, $name, $sitename, $money, $type, $notify_url, $return_url) {
        $out_trade_no = date('YmdHis').mt_rand(000,999);
        $ary = array(
            'money' => $money,
            'type' => $type,
            'out_trade_no' => $out_trade_no,
            'notify_url' => $notify_url,
            'pid' => $epaypid,
            'name' => $name,
            'return_url' => $return_url,
            'sitename' => $sitename
        );
        $pay['out_trade_no'] = $out_trade_no;
        $pay['money'] = $money;
        $pay['username'] = session('username');
        $pay['date'] = date('Y-m-d');
        if (!Db::table('pay')->insert($pay)) {
            Tips::error('创建订单失败', '/user');
        }
        $this->submit($ary, $epaylink, $epaykey);
    }
    public function submit($ary, $epaylink, $epaykey) {
        $arylink = $this->arylink($this->arysort($ary));
        $ary['sign'] = $this->md5sign($arylink, $epaykey);
        $ary['sign_type'] = 'MD5';

        $action = $epaylink.'submit.php?_input_charset=utf-8';

        $html = '<form id="paysubmit" name="paysubmit" action="'.$action.'">';
        while (list ($key, $val) = Pub::fun_adm_each($ary)) {
            $html.= '<input hidden name="'.$key.'" value="'.$val.'">';
        }
        $html .= '<input hidden type="submit"></form><script>document.forms["paysubmit"].submit();</script>';

        exit($html);
    }
    public static function returnp($out_trade_no) {
        $data = self::getpay($out_trade_no);

        if ($data['code'] == 1 && $data['status'] == 1) {
            // 验证成功
            $out_trade_no = $data['out_trade_no'];
            $paydata = Db::table('pay')->where(array('out_trade_no' => $out_trade_no))->find();

            if (empty($paydata)) {
                Tips::error('订单不存在，有疑问请联系管理员。', '/user');
            }
            if ($paydata['state'] == 1) {
                Tips::error('订单已成功充值，有疑问请联系管理员。', '/user');

            }
            if ($paydata['money'] != $data['money']) {
                Tips::error('充值金额有误，有疑问请联系管理员。', '/user');
            }

            $user = Db::table('user')->where(array('username' => session('username')))->find();
            $paydata['money'] = $paydata['money'] + $paydata['money'] * (Config::get('website')['payfree'] / 100);
            if (!Db::table('user')->where(array('username' => session('username')))->update(['usermoney'=>$user['usermoney'] + $paydata['money']])) {
                Tips::error('充值失败，有疑问请联系管理员。', '/user');
            }
            if (!Db::table('pay')->where(array('out_trade_no' => $paydata['out_trade_no']))->update(['state'=>1])) {
                Tips::error('修改状态失败，有疑问请联系管理员。', '/user');
            }
            Pub::LingduMsg('充值成功提醒！','充值金额：'.$paydata['money'].'<br/>现有余额：'.$user['usermoney'] + $paydata['money'].'<br/>充值用户：'.session('username').'<br/>欢迎您下次充值！',session('username'));
            Pub::LingduMsgs('用户充值提醒！','用户充值金额：'.$paydata['money'].'<br/>用户目前余额：'.$user['usermoney'] + $paydata['money'].'<br/>充值用户：'.session('username'));
            Tips::success('充值成功，请稍后。', '/user');
        } else {
            // 验证失败
            Tips::error('验证失败，订单不存在或未支付。', '/user');
        }
    }
    public function arysort($ary) {
        ksort($ary);
        reset($ary);
        return $ary;
    }
    public function arylink($ary) {
        $arg = "";
        while (list ($key, $val) = Pub::fun_adm_each ($ary)) {
            $arg.= $key."=".$val."&";
        }
       $arg = substr($arg,0,strlen($arg)-1);

        if (get_magic_quotes_gpc()) {
            $arg = stripslashes($arg);
        }

        return $arg;
    }
    public function md5sign($arylink, $key) {
        $arylink = $arylink.$key;
        return md5($arylink);
    }
    public static function getpay($out_trade_no) {
        $web =Config::get('website');
        $epaylink = $web['epaylink'];
        $epaypid = $web['epaypid'];
        $epaykey = $web['epaykey'];

        $apiurl = $epaylink.'api.php?act=order&pid='.$epaypid.'&key='.$epaykey.'&out_trade_no='.$out_trade_no;

      
        return json_decode(Pub::curl_request($apiurl),true);
    }
}