<?php

namespace app\user\library;
use think\exception\HttpResponseException;
use think\facade\Config;
class Tips
{
    public static function success($msg = '', string $url = null, $data = '', int $wait = 1, array $header = [])
    {
        if (is_null($url)) {
             $url = request()->isAjax() ? '' : 'javascript:history.back(-1);';
        } elseif ($url) {
            $url = (strpos($url, '://') || 0 === strpos($url, '/')) ? $url : app('route')->buildUrl($url);
        }

        $result = [
            'code' => 1,
            'msg'  => $msg,
            'data' => $data,
            'url'  => $url,
            'wait' => $wait,
        ];

       
         $response = view(config('app.dispatch_success_tmpl'), array_merge($result,['cdn'=>Config::get('website')['cdn']]));
  

        throw new HttpResponseException($response);
    }
    public static function error($msg = '', string $url = null, $data = '', int $wait = 3, array $header = [])
    {
        if (is_null($url)) {
            $url = request()->isAjax() ? '' : 'javascript:history.back(-1);';
        } elseif ($url) {
            $url = (strpos($url, '://') || 0 === strpos($url, '/')) ? $url : $this->app->route->buildUrl($url);
        }

        $result = [
            'code' => 0,
            'msg'  => $msg,
            'data' => $data,
            'url'  => $url,
            'wait' => $wait,
        ];

           $response = view(config('app.dispatch_success_tmpl'), array_merge($result,['cdn'=>Config::get('website')['cdn']]));
       

        throw new HttpResponseException($response);
    }
}